/* drivers/staging/android/kcjlogger.h
 *
 * This software is contributed or developed by KYOCERA Corporation.
 * (C) 2011 KYOCERA Corporation
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */
#ifndef _LINUX_KCJLOGGER_H
#define _LINUX_KCJLOGGER_H

#include <linux/types.h>
#include <linux/ioctl.h>

struct kcjlogger_entry {
	__u16		len;	/* length of the payload */
	__u16		__pad;	/* no matter what, we get 2 bytes of padding */
	__s32		pid;	/* generating process's pid */
	__s32		tid;	/* generating process's tid */
	__s32		sec;	/* seconds since Epoch */
	__s32		nsec;	/* nanoseconds */
	char		msg[0];	/* the entry's payload */
};

#define LOGGER_LOG_KCJ			"log_kcj"	/* KcjLog */

#define KCJLOGGER_ENTRY_MAX_LEN		(4*1024)
#define KCJLOGGER_ENTRY_MAX_PAYLOAD	\
	(KCJLOGGER_ENTRY_MAX_LEN - sizeof(struct kcjlogger_entry))

#define __KCJLOGGERIO	0xAE                            /* must be same as __LOGGERIO */

#define KCJLOGGER_GET_LOG_BUF_SIZE	_IO(__KCJLOGGERIO, 1) /* size of log */
#define KCJLOGGER_GET_LOG_LEN		_IO(__KCJLOGGERIO, 2) /* used log len */
#define KCJLOGGER_GET_NEXT_ENTRY_LEN	_IO(__KCJLOGGERIO, 3) /* next entry len */
#define KCJLOGGER_FLUSH_LOG		_IO(__KCJLOGGERIO, 4) /* flush log */

#define KCJLOGGER_LOGCONTROL		_IO(__KCJLOGGERIO, 8) /* temprary log control */

#endif /* _LINUX_LOGGER_H */
