/* This software is contributed or developed by KYOCERA Corporation. */
/* (C) 2011 KYOCERA Corporation                                      */

#ifdef CONFIG_KYOCERA_ORIGINAL_FEATURE
#ifndef DTS_H
#define DTS_H

#define DTS_LCD_FBPRINT             (0)
#define DTS_LCD_DISPLAY_UPDATE      (0)

#ifndef FEATURE_LCDBL_AAT3369
#define FEATURE_LCDBL_AAT3369
#endif

#define DTS_LCD_SCALE               (2)
#define DTS_LCD_NUMBER_OF_IBUF      (2+1)


#define DTS_LCD_POLLING_TIME            3000

#define DTS_LCD_WS21_INTER_HW_VER   0x30313032
#define DTS_LCD_WS23_INTER_HW_VER   0x30313034
#define DTS_LCD_WS3_INTER_HW_VER    0x30313035
#define DTS_LCD_OUTER_HW_VER_0102   0x30313032

typedef enum {
    DTS_UPDATE_START,
    DTS_UPDATE_VSYNC_MDDI_PRIM,
    DTS_UPDATE_VSYNC_RGB,
    DTS_UPDATE_DMA_S_DONE,
    DTS_UPDATE_DMA_P_DONE,
#if DTS_LCD_FBPRINT
    DTS_UPDATE_FBPRINT,
#endif
    DTS_UPDATE_END
} DTS_UPDATE_EVENT;

#define DTS_SMI_TO_VIRT(p, i) \
    (p + (int)((i)->screen_base) - (int)((i)->fix.smem_start))

#if DTS_LCD_DISPLAY_UPDATE
extern int is_display_update;
#endif


extern void dts_update_proc(DTS_UPDATE_EVENT evt, struct fb_info *info, void *data);
extern void dts_clear_ibuf2(void);

#if DTS_LCD_FBPRINT
#include <linux/fbprint.h>
extern int mdp_chk_fbprint(struct fb_info *info, struct mdp_dirty_region *dirtyPtr);
extern void mdp_ppp_fbprint(struct fb_info *info);
extern void mdp_dma_fbprint(struct fb_info *info);
#endif

extern boolean hs_lcd_testmode_frex_check_drv( void );
extern boolean mddi_lcd_status_get( void );

#define LCD_BACKLIGHT_ALL           0
#define LCD_BACKLIGHT_UP            1
#define LCD_BACKLIGHT_DOWN          2
extern void aat3369bl_on(int intensity, int updown);
extern void aat3369bl_off(int updown);


#endif
#endif
