/* This software is contributed or developed by KYOCERA Corporation. */
/* (C) 2011 KYOCERA Corporation                                      */

#ifdef CONFIG_KYOCERA_ORIGINAL_FEATURE
#include "msm_fb.h"
#include "mddihost.h"

extern uint32_t dts_lcd_internal_hw_version;

static int __init dts_panel_init(void)
{
	int ret;
	struct msm_panel_info pinfo;

    pinfo.xres                      = 480;
    pinfo.yres                      = 800;
    pinfo.bpp                       = 18;

    pinfo.wait_cycle                = 0;

    pinfo.bl_max                    = 0;
    pinfo.bl_min                    = 0;
    pinfo.fb_num                    = 2;



    pinfo.mddi.vdopkt               = MDDI_DEFAULT_PRIM_PIX_ATTR;

    pinfo.pdest                     = DISPLAY_1;
    pinfo.type                      = MDDI_PANEL;

	pinfo.clk_rate                  = 384000000;
    pinfo.clk_min                   = 384000000;
    pinfo.clk_max                   = 400000000;

    pinfo.lcd.vsync_enable          = FALSE;
    pinfo.lcd.refx100               = 6244;
    pinfo.lcd.v_back_porch          = 8;
    pinfo.lcd.v_front_porch         = 12;
    pinfo.lcd.v_pulse_width         = 5;
    pinfo.lcd.hw_vsync_mode         = FALSE;
    pinfo.lcd.vsync_notifier_period = (1 * HZ);

    ret = mddi_dts_device_register(&pinfo);
    if (ret) {
        printk(KERN_ERR "%s: failed to register device!<UP>\n", __func__);
        return ret;
    }

    pinfo.pdest                     = DISPLAY_2;
	pinfo.type                      = LCDC_PANEL;

	pinfo.clk_rate                  = 27027000;
    pinfo.clk_min                   = 26000000;
    pinfo.clk_max                   = 28000000;
    if(dts_lcd_internal_hw_version == DTS_LCD_WS21_INTER_HW_VER)
    {
	    pinfo.clk_rate                  = 30720000;
        pinfo.clk_min                   = 30720000;
        pinfo.clk_max                   = 37000000;
    }

	pinfo.lcdc.h_pulse_width        = 10;
	pinfo.lcdc.h_back_porch         = 22 - pinfo.lcdc.h_pulse_width;
	pinfo.lcdc.h_front_porch        = 10;
	pinfo.lcdc.v_pulse_width        = 2;
	pinfo.lcdc.v_back_porch         = 10 - pinfo.lcdc.v_pulse_width;
	pinfo.lcdc.v_front_porch        = 10;
	pinfo.lcdc.border_clr           = 0x000000;
	pinfo.lcdc.underflow_clr        = 0x000000;
	pinfo.lcdc.hsync_skew           = 0;

	ret = lcdc_device_register(&pinfo);
    if (ret) {
        printk(KERN_ERR "%s: failed to register device!<DOWN>\n", __func__);
    }

	return ret;
}

module_init(dts_panel_init);
#endif 
