/* This software is contributed or developed by KYOCERA Corporation. */
/* (C) 2011 KYOCERA Corporation                                      */

#ifdef  CONFIG_KYOCERA_ORIGINAL_FEATURE
#include <linux/gpio.h>
#include "msm_fb.h"
#include "mddihost.h"
#include "mddihosti.h"
#include <mach/hs_io_ctl_a.h> 
#include <mach/open_and_close.h> 

#include <mach/msm_battery.h>

#define FEATURE_USE_QSD_GPIO


#define MDDI_CLIENT_CORE_BASE   0x108000
#define LCD_CONTROL_BLOCK_BASE  0x110000
#define SPI_BLOCK_BASE          0x120000
#define PWM_BLOCK_BASE          0x140000
#define GPIO_BLOCK_BASE         0x150000
#define SYSTEM_BLOCK1_BASE      0x160000
#define SYSTEM_BLOCK2_BASE      0x170000

#define TTBUSSEL    (MDDI_CLIENT_CORE_BASE|0x18)
#define DPSET0      (MDDI_CLIENT_CORE_BASE|0x1C)
#define DPSET1      (MDDI_CLIENT_CORE_BASE|0x20)
#define DPSUS       (MDDI_CLIENT_CORE_BASE|0x24)
#define DPRUN       (MDDI_CLIENT_CORE_BASE|0x28)
#define SYSCKENA    (MDDI_CLIENT_CORE_BASE|0x2C)

#define BITMAP0     (MDDI_CLIENT_CORE_BASE|0x44)
#define BITMAP1     (MDDI_CLIENT_CORE_BASE|0x48)
#define BITMAP2     (MDDI_CLIENT_CORE_BASE|0x4C)
#define BITMAP3     (MDDI_CLIENT_CORE_BASE|0x50)
#define BITMAP4     (MDDI_CLIENT_CORE_BASE|0x54)

#define SRST        (LCD_CONTROL_BLOCK_BASE|0x00)
#define PORT_ENB    (LCD_CONTROL_BLOCK_BASE|0x04)
#define START       (LCD_CONTROL_BLOCK_BASE|0x08)
#define PORT        (LCD_CONTROL_BLOCK_BASE|0x0C)
#define CMN         (LCD_CONTROL_BLOCK_BASE|0x10)

#define INTFLG      (LCD_CONTROL_BLOCK_BASE|0x18)
#define INTMSK      (LCD_CONTROL_BLOCK_BASE|0x1C)
#define MPLFBUF     (LCD_CONTROL_BLOCK_BASE|0x20)

#define PXL         (LCD_CONTROL_BLOCK_BASE|0x30)
#define HCYCLE      (LCD_CONTROL_BLOCK_BASE|0x34)
#define HSW         (LCD_CONTROL_BLOCK_BASE|0x38)
#define HDE_START   (LCD_CONTROL_BLOCK_BASE|0x3C)
#define HDE_SIZE    (LCD_CONTROL_BLOCK_BASE|0x40)
#define VCYCLE      (LCD_CONTROL_BLOCK_BASE|0x44)
#define VSW         (LCD_CONTROL_BLOCK_BASE|0x48)
#define VDE_START   (LCD_CONTROL_BLOCK_BASE|0x4C)
#define VDE_SIZE    (LCD_CONTROL_BLOCK_BASE|0x50)

#define WAKEUP      (LCD_CONTROL_BLOCK_BASE|0x54)
#define REGENB      (LCD_CONTROL_BLOCK_BASE|0x5C)
#define VSYNIF      (LCD_CONTROL_BLOCK_BASE|0x60)
#define WRSTB       (LCD_CONTROL_BLOCK_BASE|0x64)
#define RDSTB       (LCD_CONTROL_BLOCK_BASE|0x68)

#define ASY_DATA    (LCD_CONTROL_BLOCK_BASE|0x6C)
#define ASY_DATB    (LCD_CONTROL_BLOCK_BASE|0x70)
#define ASY_DATC    (LCD_CONTROL_BLOCK_BASE|0x74)
#define ASY_DATD    (LCD_CONTROL_BLOCK_BASE|0x78)
#define ASY_DATE    (LCD_CONTROL_BLOCK_BASE|0x7C)
#define ASY_DATF    (LCD_CONTROL_BLOCK_BASE|0x80)
#define ASY_DATG    (LCD_CONTROL_BLOCK_BASE|0x84)
#define ASY_DATH    (LCD_CONTROL_BLOCK_BASE|0x88)
#define ASY_CMDSET  (LCD_CONTROL_BLOCK_BASE|0x8C)
#define MONI        (LCD_CONTROL_BLOCK_BASE|0xB0)
#define VPOS        (LCD_CONTROL_BLOCK_BASE|0xC0)

#define SSICTL      (SPI_BLOCK_BASE|0x00)
#define SSITIME     (SPI_BLOCK_BASE|0x04)
#define SSITX       (SPI_BLOCK_BASE|0x08)
#define SSIRX       (SPI_BLOCK_BASE|0x0C)
#define SSIINTC     (SPI_BLOCK_BASE|0x10)
#define SSIINTS     (SPI_BLOCK_BASE|0x14)

#define SSIINTS_SIFACT  (0x00001000)
#define SSIINTS_INTSTXO (0x00000004)

#define TIMER0LOAD  (PWM_BLOCK_BASE|0x00)
#define TIMER0CTRL  (PWM_BLOCK_BASE|0x08)
#define PWM0OFF     (PWM_BLOCK_BASE|0x1C)
#define TIMER1LOAD  (PWM_BLOCK_BASE|0x20)
#define TIMER1CTRL  (PWM_BLOCK_BASE|0x28)
#define PWM1OFF     (PWM_BLOCK_BASE|0x3C)
#define TIMER2LOAD  (PWM_BLOCK_BASE|0x40)
#define TIMER2CTRL  (PWM_BLOCK_BASE|0x48)
#define PWM2OFF     (PWM_BLOCK_BASE|0x5C)
#define PWMCR       (PWM_BLOCK_BASE|0x68)

#define GPIODATA    (GPIO_BLOCK_BASE|0x00)
#define GPIODIR     (GPIO_BLOCK_BASE|0x04)
#define GPIOIS      (GPIO_BLOCK_BASE|0x08)
#define GPIOIEV     (GPIO_BLOCK_BASE|0x10)
#define GPIOIC      (GPIO_BLOCK_BASE|0x20)
#define GPIOPC      (GPIO_BLOCK_BASE|0x28)

#define WKREQ       (SYSTEM_BLOCK1_BASE|0x00)
#define CLKENB      (SYSTEM_BLOCK1_BASE|0x04)
#define DRAMPWR     (SYSTEM_BLOCK1_BASE|0x08)
#define INTMASK     (SYSTEM_BLOCK1_BASE|0x0C)
#define CNT_DIS     (SYSTEM_BLOCK1_BASE|0x10)

#define GPIOSEL     (SYSTEM_BLOCK2_BASE|0x00)


#define SSICTL_SPOD     0x00080000
#define SSICTL_LOSDIR   0x00040000
#define SSICTL_LOCSPL   0x00020000
#define SSICTL_LODMY    0x00010000

#define SSICTL_SPLOSEL  0x00000008
#define SSICTL_SETACT   0x00000002

#define SSI_TX_SETTING  (SSICTL_LOSDIR|SSICTL_SPLOSEL)
#define SSI_TX_START    (SSICTL_LOSDIR|SSICTL_SPLOSEL|SSICTL_SETACT)

#define SSITX_CONT      0x00080000
#define SSITX_WRITE     0x00000000
#define SSITX_READ      0x00040000
#define SSITX_1BYTE     0x00000000
#define SSITX_2BYTE     0x00010000
#define SSITX_3BYTE     0x00020000
#define SSITX_4BYTE     0x00030000

#define PANEL_WR(n)     (SSITX_WRITE|SSITX_1BYTE|n)
#define PANEL_WR2(n)    (SSITX_WRITE|SSITX_2BYTE|n)
#define PANEL_RD(n)     (SSITX_READ |SSITX_1BYTE|n)
#define PANEL_RD2(n)    (SSITX_READ |SSITX_2BYTE|n)
#define PANEL_RD3(n)    (SSITX_READ |SSITX_3BYTE|n)
#define PANEL_RD4(n)    (SSITX_READ |SSITX_4BYTE|n)

#define DTS_LCD_ALL     0
#define DTS_LCD_UP      1
#define DTS_LCD_DOWN    2

#define HS_SPI_RETRY_CNT 5

#define WRITE_CLIENT_REG(reg_addr, reg_val) \
    mddi_host_register_write(reg_addr, reg_val, MDDI_DATA_PACKET_4_BYTES, TRUE, NULL, MDDI_HOST_PRIM)

#define DTS_LCD_OPEN        1
#define DTS_LCD_CLOSE       0
#define DTS_LCD_OPEN_CLOSE  -1

extern void lcdc_mdp_register_start(void);
extern void lcdc_mdp_register_stop(void);
extern uint8    dts_lcd_lcd_gamma[2][3][18];
extern void dts_lcd_get_nv_data(int updown);
extern void dts_gpio_tantai_settings(void);
void mddi_lcd_kernel_init( void );

#ifdef FEATURE_LCDBL_AAT3369
extern int aat3369bl_resume_flag;
extern int aat3369bl_resume_data_up;
extern int aat3369bl_resume_data_down;
extern void aat3369bl_send_intensity(int intensity, int updown);
extern int aat3369bl_now_data;
#endif

extern uint32_t dts_lcd_internal_hw_version;
extern struct timer_list timer_dts_lcd_polling;
extern boolean dts_lcd_register_read_state;

extern void lcdc_close_setting(void);
extern void lcdc_open_setting(void);
extern boolean mdp_dma_lcdc_status;

extern uint32_t dts_lcd_external_hw_version;

typedef enum {
    TOSHIBA_STATE_OFF,
    TOSHIBA_STATE_STANDBY,
    TOSHIBA_STATE_READY,
    TOSHIBA_STATE_NORMAL_MODE,
    TOSHIBA_STATE_SUSPEND,
    TOSHIBA_STATE_INIT,
} mddi_toshiba_state_t;


static mddi_toshiba_state_t toshiba_state = TOSHIBA_STATE_INIT;

static struct msm_panel_common_pdata *mddi_dts_pdata;

int dts_lcd_flag_black_pict=0;
struct delayed_work dts_lcd_pict_chg_work;
void dts_lcd_set_nomal_pict(struct work_struct *work);
void lcd_set_backlight_value(int value, int updown);
int dts_lcd_backlight_changing=0;
int dts_lcd_register_read_flg = FALSE;

int dts_lcd_check_panel_ready=0;

boolean dts_lcd_flag_under_panel_close = TRUE;

static void send_to_r63302(int command_or_parameter, int value, int updown);
static void lcd_panel_on_registr_settings(int updown);
boolean dts_lcd_flag_panel_restarting = FALSE;

boolean dts_lcd_flag_resume_start_backlight = FALSE;
boolean dts_lcd_flag_kernel_init_start = FALSE;

int dts_lcd_check_mddi_state(void)
{
    return (int)toshiba_state;
}

static inline void toshiba_reset_mddi(void)
{
    gpio_set_value(GPIO_LCD1_RST, 0);
    msleep(4);
    gpio_set_value(GPIO_LCD1_RST, 1);
    msleep(8);
}

static inline void toshiba_reset_lcd(void)
{
    gpio_set_value(GPIO_LCD2_RST, 0);
    mdelay(4);
    gpio_set_value(GPIO_LCD2_RST, 1);
    mdelay(8);
}

static inline void dts_reset_off(int updown)
{
    if(updown != DTS_LCD_DOWN)
    {
        WRITE_CLIENT_REG(GPIODATA,  0x00040000);
    }
    if(updown != DTS_LCD_UP)
    {
        gpio_set_value(GPIO_LCD2_RST, 0);
    }
}

int dts_lcd_check_down_lcd_reset(void)
{
    return gpio_get_value(GPIO_LCD2_RST);
}

static inline uint32 read_client_reg(uint32 reg_addr)
{
    uint32 reg_val;

    mddi_host_register_read(reg_addr, &reg_val, TRUE, MDDI_HOST_PRIM);
    return reg_val;
}

#define LCD_PANEL_COMMAND   0
#define LCD_PANEL_PARAMETER 1

#ifdef  FEATURE_USE_QSD_GPIO
void send_to_r63302_by_QSD_GPIO(int com_or_para, int l_value)
{
    int i,data=0;

    gpio_set_value(GPIO_LCD2_SPICS0, 0);
    udelay(10);
    if( com_or_para == LCD_PANEL_COMMAND) {
        gpio_set_value(GPIO_LCD2_SPISO, 0);
    } else {
        gpio_set_value(GPIO_LCD2_SPISO, 1);
    }
    udelay(1);
    gpio_set_value(GPIO_LCD2_SPICLK, 1);
    udelay(1);
    for(i=0;i<8;i++){
        data = (0x1<<(7-i)) & l_value ? 1:0;
        gpio_set_value(GPIO_LCD2_SPICLK, 0);
        gpio_set_value(GPIO_LCD2_SPISO, data);
        udelay(1);
        gpio_set_value(GPIO_LCD2_SPICLK, 1);
        udelay(1);
    }
    gpio_set_value(GPIO_LCD2_SPICLK, 0);
    udelay(1);
    gpio_set_value(GPIO_LCD2_SPICS0, 1);
    udelay(100);
}

int read_from_r63302_by_QSD_GPIO(int command)
{
    int i,data=0;
    int l_data=0;

    send_to_r63302_by_QSD_GPIO(LCD_PANEL_COMMAND, 0xF5);
    gpio_set_value(GPIO_LCD2_SPICS0, 0);
    udelay(10);
    gpio_set_value(GPIO_LCD2_SPISO, 0);
    udelay(1);
    gpio_set_value(GPIO_LCD2_SPICLK, 1);
    udelay(1);
    command &= 0xFF;
    for(i=0;i<8;i++){
        data = (0x1<<(7-i)) & command ? 1:0;
        gpio_set_value(GPIO_LCD2_SPICLK, 0);
        gpio_set_value(GPIO_LCD2_SPISO, data);
        udelay(1);
        gpio_set_value(GPIO_LCD2_SPICLK, 1);
        udelay(1);
    }
    data=0;
    for(i=0;i<8;i++){
        gpio_set_value(GPIO_LCD2_SPICLK, 0);
        udelay(1);
        l_data = (int)gpio_get_value(GPIO_LCD2_SPISI);
        if(l_data)
        {
            data |= l_data << (7-i);
        }
        gpio_set_value(GPIO_LCD2_SPICLK, 1);
        udelay(1);
    }
    gpio_set_value(GPIO_LCD2_SPICS0, 1);
    udelay(100);
    send_to_r63302_by_QSD_GPIO(LCD_PANEL_COMMAND, 0xF6);

    return data;
}
#endif 

static uint32 send_to_r63302_read_panel(int value)
{
    uint32 val=0;
    int i;

    if(HS_A_IS_MDDI_NOT_CONNECT()) {
        return val;
    }

    if (SSIINTS_SIFACT & read_client_reg(SSIINTS)) {
        printk(KERN_ERR "ERROR!! MDDI set SSITX NG!  CS0 val=[0x%x]\n",value);
    }
    else
    {
    }    
    WRITE_CLIENT_REG(SSITX,     PANEL_RD(value));
    WRITE_CLIENT_REG(GPIODATA,  0x00400000);
    WRITE_CLIENT_REG(SSICTL,    SSI_TX_START);
    for(i=0; i<3; i++)
    {
        mddi_wait(1);
        val = read_client_reg(SSIINTS);
        if (val & 0x00000200) {
            val = read_client_reg(SSIRX);
            break;
        }else{
            printk(KERN_ERR "MEMO:                                 command 0x%X read NG i = [%d]\n", value, i);
        }
    }
    WRITE_CLIENT_REG(GPIODATA,  0x00400040);

    WRITE_CLIENT_REG(SSICTL,    SSI_TX_SETTING);
    return val;
}

void dts_lcd_restart_panel(int updown)
{
    WRITE_CLIENT_REG(GPIODATA,  0x00040004);
    if(updown != DTS_LCD_UP)
    {
        gpio_set_value(GPIO_LCD2_RST, 1);
    }
    mddi_wait(10);
    WRITE_CLIENT_REG(SSICTL,    SSI_TX_SETTING);
    WRITE_CLIENT_REG(SSITIME,   0x00001000);
    WRITE_CLIENT_REG(CNT_DIS,   0x00000000);
    lcd_panel_on_registr_settings(updown);
    mddi_wait(100);
    dts_lcd_flag_panel_restarting = FALSE;
}

void dts_lcd_panel_registar_read(void)
{
    boolean l_flag_go_restart = FALSE;
    int updown = DTS_LCD_ALL;
    int l_save_bl_val=0;

    dts_lcd_flag_panel_restarting = FALSE;
    if (!dts_lcd_register_read_flg)
    {
        printk(KERN_ERR "%s()dts_lcd_register_read_flg is FALSE not read and restart!!!\n", __func__);
        return;
    }
    if(dts_lcd_backlight_changing)
    {
        printk(KERN_ERR "%s()back light is setting now!!\n", __func__);
        return;
    }
    if(!dts_lcd_flag_under_panel_close)
    {
        if(0x14 != read_from_r63302_by_QSD_GPIO(0x0A))
        {
            printk(KERN_ERR "%s()under read error!! goto restart!!!\n", __func__);
            l_flag_go_restart = TRUE;
        }
    }
    if(0x14 != send_to_r63302_read_panel(0x0A))
    {
        printk(KERN_ERR "%s()upper read error!! goto restart!!!\n", __func__);
        l_flag_go_restart = TRUE;
    }


    if(l_flag_go_restart)
    {
        printk(KERN_ERR "%s()do restart!!!\n", __func__);
        if(dts_lcd_flag_under_panel_close)
        {
            updown = DTS_LCD_UP;
        }
        l_save_bl_val = aat3369bl_now_data; 

        aat3369bl_send_intensity(0, DTS_LCD_ALL);
        mddi_wait(10);
        dts_lcd_flag_panel_restarting = TRUE;
        WRITE_CLIENT_REG(SSICTL,    SSI_TX_SETTING);
        send_to_r63302(LCD_PANEL_COMMAND, 0x28, updown);
        send_to_r63302(LCD_PANEL_COMMAND, 0x10, updown);
        mddi_wait(200);
        dts_reset_off(updown);
        mddi_wait(4);
        dts_lcd_restart_panel(updown);
        aat3369bl_send_intensity(l_save_bl_val, updown);
    }
}

static void send_to_r63302(int command_or_parameter, int value, int updown)
{

    if(HS_A_IS_MDDI_NOT_CONNECT()) {
        return;
    }

    if(updown != DTS_LCD_DOWN) {
		if (SSIINTS_SIFACT & read_client_reg(SSIINTS)) {
		    printk(KERN_ERR "ERROR!! MDDI set SSITX NG!  CS0 val=[0x%x]\n",value);
		} else {
		}    
    	if(command_or_parameter == LCD_PANEL_PARAMETER) {
    	    WRITE_CLIENT_REG(SSITX,     PANEL_WR(0x100 | value));
    	} else {
    	    WRITE_CLIENT_REG(SSITX,     PANEL_WR(value));
    	}
    	WRITE_CLIENT_REG(GPIODATA,  0x00400000); 
    	WRITE_CLIENT_REG(SSICTL,    SSI_TX_START);
		udelay(100);
    	WRITE_CLIENT_REG(GPIODATA,  0x00400040); 

    	WRITE_CLIENT_REG(SSICTL,    SSI_TX_SETTING);
	}

    if(updown != DTS_LCD_UP) {
#ifdef FEATURE_USE_QSD_GPIO
    	send_to_r63302_by_QSD_GPIO(command_or_parameter, value);
#else 
		if (SSIINTS_SIFACT & read_client_reg(SSIINTS)) {
		    printk(KERN_ERR "ERROR!! MDDI set SSITX NG!  CS1 val=[0x%x]\n",value);
		} else {
		}    
    	if(command_or_parameter == LCD_PANEL_PARAMETER) {
    	    WRITE_CLIENT_REG(SSITX,     PANEL_WR(0x100 | value));
    	} else {
    	    WRITE_CLIENT_REG(SSITX,     PANEL_WR(value));
    	}    
    	WRITE_CLIENT_REG(GPIODATA,  0x00800000);
    	WRITE_CLIENT_REG(SSICTL,    SSI_TX_START);
		udelay(100);
    	WRITE_CLIENT_REG(GPIODATA,  0x00800080);
    	WRITE_CLIENT_REG(SSICTL,    SSI_TX_SETTING);
#endif 
	}
}

static void lcd_panel_set_factory_mode(int updown)
{
    send_to_r63302(LCD_PANEL_COMMAND, 0xB0, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x00, updown);
}

static void lcd_panel_exit_factory_mode(int updown)
{
    send_to_r63302(LCD_PANEL_COMMAND, 0xB0, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x03, updown);
}

static void set_gamma_data_to_panel(int up_or_down)
{
    int i,j;

    send_to_r63302(LCD_PANEL_COMMAND, 0xCB, up_or_down);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x01, up_or_down);
    for(i=0; i<3; i++)
    {
        send_to_r63302(LCD_PANEL_COMMAND, 0xC8+i, up_or_down);
        for(j=0; j<18; j++)
        {
            if(up_or_down == DTS_LCD_UP)
            {
                send_to_r63302(LCD_PANEL_PARAMETER, dts_lcd_lcd_gamma[0][i][j], up_or_down);
            }
            else
            {
                send_to_r63302(LCD_PANEL_PARAMETER, dts_lcd_lcd_gamma[1][i][j], up_or_down);
            }
        }
    }
}

void set_gamma_data_from_NV(int updown)
{
    if(updown != DTS_LCD_DOWN)
    {
        lcd_panel_set_factory_mode(DTS_LCD_UP);
        set_gamma_data_to_panel(DTS_LCD_UP);
        lcd_panel_exit_factory_mode(DTS_LCD_UP);
    }
    if(updown != DTS_LCD_UP)
    {
        lcd_panel_set_factory_mode(DTS_LCD_DOWN);
        set_gamma_data_to_panel(DTS_LCD_DOWN);
        lcd_panel_exit_factory_mode(DTS_LCD_DOWN);
    }
}

void dts_lcd_set_frame_mode(int updown)
{
    if(dts_lcd_internal_hw_version == DTS_LCD_WS21_INTER_HW_VER)
    {
        if(updown != DTS_LCD_DOWN)
        {
            WRITE_CLIENT_REG(CLKENB,    0x000000CB);
            WRITE_CLIENT_REG(CLKENB,    0x0000A1CB);
        }
        lcd_panel_set_factory_mode(updown);
        send_to_r63302(LCD_PANEL_COMMAND, 0x3A, updown);
        send_to_r63302(LCD_PANEL_PARAMETER, 0x60, updown);
        send_to_r63302(LCD_PANEL_COMMAND, 0xC1, updown);
        send_to_r63302(LCD_PANEL_PARAMETER, 0x00, updown);
        send_to_r63302(LCD_PANEL_PARAMETER, 0x40, updown);
        send_to_r63302(LCD_PANEL_PARAMETER, 0x00, updown);
        set_gamma_data_from_NV(updown);

        lcd_panel_exit_factory_mode(updown);
    }
    else
    {
        lcd_panel_set_factory_mode(updown);
        if(dts_lcd_internal_hw_version < DTS_LCD_WS3_INTER_HW_VER)
        {
            send_to_r63302(LCD_PANEL_COMMAND, 0x3A, updown);
            send_to_r63302(LCD_PANEL_PARAMETER, 0x60, updown);
        }
        send_to_r63302(LCD_PANEL_COMMAND, 0xC1, updown);
        send_to_r63302(LCD_PANEL_PARAMETER, 0x80, updown);
        send_to_r63302(LCD_PANEL_PARAMETER, 0x40, updown);
        send_to_r63302(LCD_PANEL_PARAMETER, 0x00, updown);
        lcd_panel_exit_factory_mode(updown);
    }
}

void dts_lcd_upper_panel_init(void)
{
    int updown = DTS_LCD_UP;
    if(dts_lcd_internal_hw_version == DTS_LCD_WS21_INTER_HW_VER)
    {
        WRITE_CLIENT_REG(CLKENB,    0x000000CB);
        WRITE_CLIENT_REG(CLKENB,    0x0000A1CB);
        lcd_panel_set_factory_mode(updown);
        send_to_r63302(LCD_PANEL_COMMAND, 0x3A, updown);
        send_to_r63302(LCD_PANEL_PARAMETER, 0x60, updown);
        send_to_r63302(LCD_PANEL_COMMAND, 0xC1, updown);
        send_to_r63302(LCD_PANEL_PARAMETER, 0x00, updown);
        send_to_r63302(LCD_PANEL_PARAMETER, 0x40, updown);
        send_to_r63302(LCD_PANEL_PARAMETER, 0x00, updown);
        set_gamma_data_from_NV(updown);
        lcd_panel_exit_factory_mode(updown);
    }
    else
    {
        if(dts_lcd_internal_hw_version == DTS_LCD_WS23_INTER_HW_VER)
        {
            lcd_panel_set_factory_mode(updown);
            send_to_r63302(LCD_PANEL_COMMAND, 0xC1, updown);
            send_to_r63302(LCD_PANEL_PARAMETER, 0x80, updown);
            send_to_r63302(LCD_PANEL_PARAMETER, 0x40, updown);
            send_to_r63302(LCD_PANEL_PARAMETER, 0x00, updown);
            lcd_panel_exit_factory_mode(updown);
        }
        else if((dts_lcd_internal_hw_version == DTS_LCD_WS3_INTER_HW_VER)
                && (dts_lcd_external_hw_version == DTS_LCD_OUTER_HW_VER_0102))
        {
            lcd_panel_set_factory_mode(updown);
            send_to_r63302(LCD_PANEL_COMMAND, 0xC1, updown);
            send_to_r63302(LCD_PANEL_PARAMETER, 0x80, updown);
            send_to_r63302(LCD_PANEL_PARAMETER, 0x40, updown);
            send_to_r63302(LCD_PANEL_PARAMETER, 0x00, updown);
            lcd_panel_exit_factory_mode(updown);
        }
    }
}

static void lcd_panel_on_registr_settings(int updown)
{
    send_to_r63302(LCD_PANEL_COMMAND, 0x11, updown);
    msleep(120);
    dts_lcd_set_frame_mode(updown);

    lcd_panel_set_factory_mode(updown);
    send_to_r63302(LCD_PANEL_COMMAND, 0xD1, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x1A, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x14, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x02, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x2C, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x00, updown);
    send_to_r63302(LCD_PANEL_COMMAND, 0xD5, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x00, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x00, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x14, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x72, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x1E, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x00, updown);
    send_to_r63302(LCD_PANEL_COMMAND, 0xD5, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x00, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x00, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x14, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x72, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x1E, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x00, updown);

    lcd_panel_exit_factory_mode(updown);
    send_to_r63302(LCD_PANEL_COMMAND, 0x29, updown);
}

static void toshiba_common_initial_setup(struct msm_fb_data_type *mfd)
{
    int32 cnt;
    int32 i;
    uint32 val;
    int updown=DTS_LCD_ALL;

    if(HS_A_IS_MDDI_NOT_CONNECT()) {
        dts_gpio_tantai_settings();
        return;
    }

    if(get_open_close_state() != DTS_LCD_OPEN)
    {
        updown = DTS_LCD_UP;
    }


    for (cnt = 0; cnt < HS_SPI_RETRY_CNT; cnt++) {

        WRITE_CLIENT_REG(DPSET0,    0x4F4200AC);
        WRITE_CLIENT_REG(DPSET1,    0x0000010F);
        WRITE_CLIENT_REG(DPSUS,     0x00000000);
        WRITE_CLIENT_REG(DPRUN,     0x00000001);
        for (i = 0; i < 5; i++) {
            msleep(100);
            val = read_client_reg(DPSUS);

            if (val & 0x00000010) {
                break;
            }
        }


        WRITE_CLIENT_REG(SYSCKENA,  0x00000001);
        WRITE_CLIENT_REG(CLKENB,    0x000000CA);
        WRITE_CLIENT_REG(DRAMPWR,   0x00000001);
        mddi_wait(1);
        WRITE_CLIENT_REG(GPIOSEL,   0x00000100);
#ifdef  FEATURE_USE_QSD_GPIO
        WRITE_CLIENT_REG(GPIODATA,  0x00440040);
        WRITE_CLIENT_REG(GPIODIR,   0x00000044);
#else   /* FEATURE_USE_QSD_GPIO */
        WRITE_CLIENT_REG(GPIODATA,  0x00C400C0);
        WRITE_CLIENT_REG(GPIODIR,   0x000000C4);
#endif  /* FEATURE_USE_QSD_GPIO */

        WRITE_CLIENT_REG(BITMAP0,   0x032001E0);
        WRITE_CLIENT_REG(CLKENB,    0x000001CB);
        WRITE_CLIENT_REG(PORT_ENB,  0x00000001);
        WRITE_CLIENT_REG(PORT,      0x00000004);

        WRITE_CLIENT_REG(PXL,       0x00000102);
        dts_lcd_flag_black_pict=1;
        dts_lcd_flag_resume_start_backlight = TRUE;

        WRITE_CLIENT_REG(MPLFBUF,   0x00000000);

        WRITE_CLIENT_REG(HCYCLE,    0x000000FF);
        WRITE_CLIENT_REG(HSW,       0x00000004);
        WRITE_CLIENT_REG(HDE_START, 0x0000000A);
        WRITE_CLIENT_REG(HDE_SIZE,  0x000000EF);
        WRITE_CLIENT_REG(VCYCLE,    0x00000333);
        WRITE_CLIENT_REG(VSW,       0x00000001);
        WRITE_CLIENT_REG(VDE_START, 0x00000009);
        WRITE_CLIENT_REG(VDE_SIZE,  0x0000031F);
        WRITE_CLIENT_REG(START,     0x00000001);
        if(updown != DTS_LCD_UP)
        {
            toshiba_reset_lcd();
        }
        WRITE_CLIENT_REG(GPIODATA,  0x00040000);
	    mddi_wait(4);
        WRITE_CLIENT_REG(GPIODATA,  0x00040004);
	    mddi_wait(8);
        WRITE_CLIENT_REG(SSICTL,    SSI_TX_SETTING);
        WRITE_CLIENT_REG(SSITIME,   0x00001000);
        WRITE_CLIENT_REG(CNT_DIS,   0x00000000);
        lcd_panel_on_registr_settings(updown);
        val = read_client_reg(SSIINTS);
        if (val & SSIINTS_INTSTXO) {
            WRITE_CLIENT_REG(SSIINTC,   0x00003000);
            WRITE_CLIENT_REG(SSIINTS,   0x0000000F);
        }
        else {
            break;
        }
    }
}

static void toshiba_lcd_off(struct msm_fb_data_type *mfd)
{
    int updown=DTS_LCD_ALL;

    if(HS_A_IS_MDDI_NOT_CONNECT()) {
        return;
    }

    WRITE_CLIENT_REG(SSICTL,    SSI_TX_SETTING);
    send_to_r63302(LCD_PANEL_COMMAND, 0x28, updown);
    send_to_r63302(LCD_PANEL_COMMAND, 0x10, updown);
    mddi_wait(200);
}

static void toshiba_lcd_stop(struct msm_fb_data_type *mfd)
{

    if(HS_A_IS_MDDI_NOT_CONNECT()) {
        return;
    }

    WRITE_CLIENT_REG(PORT,      0x00000008);
    WRITE_CLIENT_REG(REGENB,    0x00000001);
    mddi_wait(16);
    WRITE_CLIENT_REG(PXL,       0x00000000);
    dts_lcd_flag_black_pict=0;
    dts_lcd_flag_resume_start_backlight = FALSE;
    WRITE_CLIENT_REG(START,     0x00000000); 
    WRITE_CLIENT_REG(REGENB,    0x00000001); 
    mddi_wait(32);
    WRITE_CLIENT_REG(CLKENB,    0x00000000);
    WRITE_CLIENT_REG(DRAMPWR,   0x00000000);
    WRITE_CLIENT_REG(SYSCKENA,  0x00000000);
    WRITE_CLIENT_REG(DPSUS,     0x00000001);
    WRITE_CLIENT_REG(DPRUN,     0x00000000);
}

static void mddi_toshiba_init(struct msm_fb_data_type *mfd)
{
    switch (toshiba_state) {
    case TOSHIBA_STATE_OFF:
        toshiba_reset_mddi();
        toshiba_state = TOSHIBA_STATE_STANDBY;
    case TOSHIBA_STATE_STANDBY:
        toshiba_common_initial_setup(mfd);
        toshiba_state = TOSHIBA_STATE_NORMAL_MODE;
        break;
    case TOSHIBA_STATE_INIT:
        mddi_lcd_kernel_init();
        toshiba_state = TOSHIBA_STATE_NORMAL_MODE;
        break;
    default:
        MDDI_MSG_ERR("ERROR!!%s() from state %d\n", __func__, toshiba_state);
    }
}

static void mddi_toshiba_lcd_powerdown(struct msm_fb_data_type *mfd)
{
    int updown=DTS_LCD_ALL;

    switch (toshiba_state) {
    case TOSHIBA_STATE_INIT:
    case TOSHIBA_STATE_NORMAL_MODE:
        toshiba_state = TOSHIBA_STATE_OFF;
        toshiba_lcd_off(mfd);
        dts_reset_off(updown);
        toshiba_lcd_stop(mfd);
        break;
    default:
        MDDI_MSG_ERR("ERROR!!%s() from state %d\n", __func__, toshiba_state);
    }
}

static int mddi_dts_on(struct platform_device *pdev)
{
    struct msm_fb_data_type *mfd;

    mfd = platform_get_drvdata(pdev);
    if (!mfd)
        return -ENODEV;
    if (mfd->key != MFD_KEY)
        return -EINVAL;

    mfd->dma->waiting = false;
    mfd->dma->busy = false;

    mddi_toshiba_init(mfd);

    msm_batt_oem_update_dev_info_lcd_onoff(true);
    return 0;
}

static int mddi_dts_off(struct platform_device *pdev)
{
    mddi_toshiba_lcd_powerdown(platform_get_drvdata(pdev));
    msm_batt_oem_update_dev_info_lcd_onoff(false);
    return 0;
}

static int __init mddi_dts_probe(struct platform_device *pdev)
{
    if (pdev->id == 0) {
        mddi_dts_pdata = pdev->dev.platform_data;
        return 0;
    }

    msm_fb_add_device(pdev);

    return 0;
}

static struct platform_driver this_driver = {
    .probe  = mddi_dts_probe,
    .driver = {
        .name   = "mddi_dts",
    },
};

static struct msm_fb_panel_data mddi_dts_panel_data = {
    .on         = mddi_dts_on,
    .off        = mddi_dts_off,
};


int mddi_dts_device_register(struct msm_panel_info *pinfo)
{
    struct platform_device *pdev = NULL;
    int ret;
    int pdest = (int)pinfo->pdest;
    int type =(int)pinfo->type;

#if 0
    if ((channel >= 3) || ch_used[channel])
        return -ENODEV;

    if ((channel != TOSHIBA_VGA_PRIM) &&
        mddi_toshiba_pdata && mddi_toshiba_pdata->panel_num)
        if (mddi_toshiba_pdata->panel_num() < 2)
            return -ENODEV;

    ch_used[channel] = TRUE;
#else
    if(type != MDDI_PANEL && type != LCDC_PANEL) {
        printk(KERN_ERR "ERROR!! invalid parameter for platform_device_alloc is type\n");
        return -EINVAL;
    }
    if(pdest != DISPLAY_1 && pdest != DISPLAY_2) {
        printk(KERN_ERR "ERROR!! invalid parameter for platform_device_alloc is pdest\n");
        return -EINVAL;
    }
#endif

    pdev = platform_device_alloc("mddi_dts", (int)((pdest<<16)|type));
    if (!pdev)
        return -ENOMEM;

    mddi_dts_panel_data.panel_info = *pinfo;

    ret = platform_device_add_data(pdev, &mddi_dts_panel_data,
                                    sizeof(mddi_dts_panel_data));
    if (ret) {
        printk(KERN_ERR "%s: platform_device_add_data failed!\n", __func__);
        goto err_device_put;
    }

    ret = platform_device_add(pdev);
    if (ret) {
        printk(KERN_ERR "%s: platform_device_register failed!\n", __func__);
        goto err_device_put;
    }

    return 0;

err_device_put:
    platform_device_put(pdev);
    return ret;
}

static int __init mddi_dts_init(void)
{
#ifdef  FEATURE_USE_QSD_GPIO
    gpio_tlmm_config(GPIO_CFG(GPIO_LCD2_SPICLK, 0, GPIO_OUTPUT, GPIO_PULL_DOWN, GPIO_2MA), GPIO_ENABLE);
    gpio_tlmm_config(GPIO_CFG(GPIO_LCD2_SPISO,  0, GPIO_OUTPUT, GPIO_PULL_DOWN, GPIO_2MA), GPIO_ENABLE);
    gpio_tlmm_config(GPIO_CFG(GPIO_LCD2_SPICS0,  0, GPIO_OUTPUT, GPIO_PULL_DOWN, GPIO_2MA), GPIO_ENABLE);
    gpio_tlmm_config(GPIO_CFG(GPIO_LCD2_SPISI,  0, GPIO_INPUT,  GPIO_PULL_UP,   GPIO_2MA), GPIO_ENABLE);

    gpio_direction_output(GPIO_LCD2_SPICLK,0);
    gpio_direction_output(GPIO_LCD2_SPISO,0);
    gpio_direction_output(GPIO_LCD2_SPICS0,1);
#endif 
    INIT_DELAYED_WORK(&dts_lcd_pict_chg_work, dts_lcd_set_nomal_pict);
    return platform_driver_register(&this_driver);
}

module_init(mddi_dts_init);

#ifdef FEATURE_LCDBL_AAT3369
void lcd_set_backlight_value(int value, int updown)
{
    if(HS_A_IS_MDDI_NOT_CONNECT()) {
        return;
    }

    if(dts_lcd_flag_panel_restarting)
    {
        return;
    }
    if(dts_lcd_flag_resume_start_backlight)
    {
        return;
    }
    dts_lcd_backlight_changing = 1; 
    send_to_r63302(LCD_PANEL_COMMAND, 0xB0, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x00, updown);
    send_to_r63302(LCD_PANEL_COMMAND, 0xB9, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x01, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, value, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x3F, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x08, updown);
    send_to_r63302(LCD_PANEL_COMMAND, 0xB0, updown);
    send_to_r63302(LCD_PANEL_PARAMETER, 0x03, updown);
    dts_lcd_backlight_changing = 0; 
}
#endif

void dts_lcd_under_panel_on(void)
{
    int updown = DTS_LCD_DOWN;

    if(HS_A_IS_MDDI_NOT_CONNECT()) {
        return;
    }

    lcdc_open_setting(); 
    if(mdp_dma_lcdc_status == FALSE )
    {
        mdp_pipe_ctrl(MDP_DMA2_BLOCK, MDP_BLOCK_POWER_ON, FALSE);
        mdp_dma_lcdc_status = TRUE;
    }
    toshiba_reset_lcd();
    lcd_panel_on_registr_settings(updown);
    lcdc_mdp_register_start();
    dts_lcd_flag_under_panel_close = FALSE;
    mddi_wait(100); 
}

void dts_lcd_under_panel_off(void)
{
    int updown = DTS_LCD_DOWN;

    if(HS_A_IS_MDDI_NOT_CONNECT()) {
        return;
    }

    dts_lcd_flag_under_panel_close = TRUE; 
    send_to_r63302(LCD_PANEL_COMMAND, 0x28, updown);
    send_to_r63302(LCD_PANEL_COMMAND, 0x10, updown);
    mddi_wait(200);
    dts_reset_off(updown);
    lcdc_mdp_register_stop();
    if(mdp_dma_lcdc_status == TRUE )
    {
        mdp_pipe_ctrl(MDP_DMA2_BLOCK, MDP_BLOCK_POWER_OFF, FALSE);
        mdp_dma_lcdc_status = FALSE;
    }
    lcdc_close_setting(); 
}



void dts_lcd_set_nomal_pict(struct work_struct *work)
{
    if(HS_A_IS_MDDI_NOT_CONNECT()) {
        return;
    }

    if(dts_lcd_flag_black_pict)
    {
        WRITE_CLIENT_REG(PXL,       0x00000002);
        WRITE_CLIENT_REG(REGENB,    0x00000001);
        dts_lcd_flag_black_pict=0;
        msleep(40);
#ifdef FEATURE_LCDBL_AAT3369 
            if(aat3369bl_resume_flag)
            {
                dts_lcd_flag_resume_start_backlight = FALSE; 
                aat3369bl_send_intensity(aat3369bl_resume_data_up, DTS_LCD_ALL);
                aat3369bl_resume_flag = 0;
            }
            else
            {
                printk(KERN_ERR "error :resume lcd backlight value is 0x3B to all\n");
                aat3369bl_send_intensity(0x3B, DTS_LCD_ALL);
            }
#endif 
    }
}




#define MDDI_TEST_PTN1 0x1
#define MDDI_TEST_PTN2 0xFF
#define MDDI_TEST_PTN3_1 0xFFFF
#define MDDI_TEST_PTN3_2 0x5555
#define MDDI_TEST_PTN3_3 0xAAAA
#define MDDI_TEST_PTN3_4 0x0000

#define MDDI_GRAM_ADR 0x32C3C0 

boolean hs_lcd_testmode_frex_check_drv( void )
{
    boolean ret = TRUE;
    uint16 set,i;
    uint32 val,cnt;

    printk(KERN_ERR "%s:start \n", __func__);

    for( cnt = 0; cnt < 3 ;cnt++)
    {
        ret = TRUE;
        set = MDDI_TEST_PTN1;
        for( i=0 ; i<16 ; i++ )
        {
            mddi_queue_register_write(MDDI_GRAM_ADR, set, TRUE, 0);
            mddi_queue_register_read(MDDI_GRAM_ADR, &val, TRUE, 0);
        if( val != set )
        {
            ret = FALSE;
        }
        set = set<<1;
        }
  
        set = MDDI_TEST_PTN2;
        for( i=0 ; i<8 ; i++ )
        {
            mddi_queue_register_write(MDDI_GRAM_ADR, set, TRUE, 0);
            mddi_queue_register_read(MDDI_GRAM_ADR, &val, TRUE, 0);
            if( val != set )
            {
                ret = FALSE;
            }
            set = set<<1;
        }
  
        mddi_queue_register_write(MDDI_GRAM_ADR, MDDI_TEST_PTN3_1, TRUE, 0);
        mddi_queue_register_read(MDDI_GRAM_ADR, &val, TRUE, 0);
        if( val != MDDI_TEST_PTN3_1 )
        {
            ret = FALSE;
        }
        mddi_queue_register_write(MDDI_GRAM_ADR, MDDI_TEST_PTN3_2, TRUE, 0);
        mddi_queue_register_read(MDDI_GRAM_ADR, &val, TRUE, 0);
        if( val != MDDI_TEST_PTN3_2 )
        {
            ret = FALSE;
        }
        mddi_queue_register_write(MDDI_GRAM_ADR, MDDI_TEST_PTN3_3, TRUE, 0);
        mddi_queue_register_read(MDDI_GRAM_ADR, &val, TRUE, 0);
        if( val != MDDI_TEST_PTN3_3 )
        {
            ret = FALSE;
        }
        mddi_queue_register_write(MDDI_GRAM_ADR, MDDI_TEST_PTN3_4, TRUE, 0);
        mddi_queue_register_read(MDDI_GRAM_ADR, &val, TRUE, 0);
        if( val != MDDI_TEST_PTN3_4 )
        {
            ret = FALSE;
        }
        if( ret == TRUE ) break;
    }

    printk(KERN_ERR "frex_check_drv %d:end \n", ret);
    return ret ;
}

boolean mddi_lcd_status_get( void )
{
  if(toshiba_state == TOSHIBA_STATE_NORMAL_MODE)
  {
    return(TRUE);
  }
  return(FALSE);
}






void mddi_lcd_kernel_init( void )
{
    dts_lcd_under_panel_on();
    dts_lcd_flag_kernel_init_start = TRUE;
    dts_lcd_upper_panel_init();

#ifdef FEATURE_LCDBL_AAT3369
    toshiba_state = TOSHIBA_STATE_NORMAL_MODE;
    aat3369bl_send_intensity(0x5B, LCD_BACKLIGHT_ALL);
#endif 

    if(0x14 == send_to_r63302_read_panel(0x0A))
    {
        dts_lcd_register_read_flg = TRUE;
    }
    mod_timer(&timer_dts_lcd_polling,jiffies + msecs_to_jiffies(DTS_LCD_POLLING_TIME));
    dts_lcd_register_read_state = FALSE;
    dts_lcd_check_panel_ready = 1;
}

void dts_lcd_gamma_nv_setting(int updown)
{
    dts_lcd_get_nv_data(updown);
    set_gamma_data_from_NV(updown);
}

void dts_lcd_close_under_on(void)
{
    dts_lcd_under_panel_on();
    lcd_set_backlight_value(255,LCD_BACKLIGHT_DOWN);
}
#endif 
