/*
 * This software is contributed or developed by KYOCERA Corporation.
 * (C) 2011 KYOCERA Corporation
 */

#ifndef _ASM_GENERIC_GPIO_CAM_H
#define _ASM_GENERIC_GPIO_CAM_H

#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/errno.h>

#ifdef CONFIG_GPIOLIB

#include <linux/compiler.h>

#ifndef ARCH_NR_GPIOS
#define ARCH_NR_GPIOS       256
#endif

extern int gpio_cam_export(unsigned gpio, bool direction_may_change);
extern int gpio_cam_export_link(struct device *dev, const char *name, unsigned gpio);
extern void gpio_cam_unexport(unsigned gpio);
extern int gpiochip_cam_add(struct gpio_chip *chip);
extern int gpiochip_cam_remove(struct gpio_chip *chip);
extern int gpio_cam_request(unsigned gpio, const char *label);

extern const char *gpiochip_cam_is_requested(struct gpio_chip *chip, unsigned offset);

extern void gpio_cam_free(unsigned gpio);

extern int gpio_cam_direction_input(unsigned gpio);
extern int gpio_cam_direction_output(unsigned gpio, int value);

extern void __gpio_cam_set_value(unsigned gpio, int value);
extern int __gpio_cam_get_value(unsigned gpio);
extern int __gpio_cam_cansleep(unsigned gpio);
extern int __gpio_cam_to_irq(unsigned gpio);
extern int gpio_cam_get_value_cansleep(unsigned gpio);
extern void gpio_cam_set_value_cansleep(unsigned gpio, int value);

#define gpio_cam_get_value  __gpio_cam_get_value
#define gpio_cam_set_value  __gpio_cam_set_value
#define gpio_cam_cansleep   __gpio_cam__cansleep
#define gpio_cam_to_irq __gpio_cam_to_irq

#endif

#endif
