/* kernelkcjprintk.c
 *
 * Kyocera printk
 *
 * This software is contributed or developed by KYOCERA Corporation.
 * (C) 2011 KYOCERA Corporation
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */
#include <linux/kernel.h>
#include <linux/mm.h>
#include <linux/tty.h>
#include <linux/tty_driver.h>
#include <linux/console.h>
#include <linux/init.h>
#include <linux/jiffies.h>
#include <linux/nmi.h>
#include <linux/module.h>
#include <linux/moduleparam.h>
#include <linux/interrupt.h>			/* For in_interrupt() */
#include <linux/delay.h>
#include <linux/smp.h>
#include <linux/security.h>
#include <linux/bootmem.h>
#include <linux/syscalls.h>
#include <linux/kexec.h>
#include <linux/kcjprintk.h>
#include <asm/uaccess.h>

static  int kcjprintk_OutputMode=0;

int kcjprintk_getOutputMode(void)
{
    int mode = false;
    if(kcjprintk_OutputMode != false)
    {
        mode = true;
    }
    /*printk("kcjprintk_OutputMode (get)== %d\n",mode);*/
    return (mode);
}
EXPORT_SYMBOL(kcjprintk_getOutputMode);

void kcjprintk_setOutputMode(int mode)
{
    /*printk("KcjLogOutputMode (before)== %d\n",kcjprintk_OutputMode);*/
    if(mode != 0)
    {
        kcjprintk_OutputMode=true;
    }else{
        kcjprintk_OutputMode=false;
    }
    /*printk("KcjLogOutputMode (after)== %d\n",kcjprintk_OutputMode);*/
}
EXPORT_SYMBOL(kcjprintk_setOutputMode);

asmlinkage int kcjprintk(const char *fmt, ...)
{
	va_list args;
	int r;

    if( kcjprintk_getOutputMode() == true )
    {
	    va_start(args, fmt);
	    r = vprintk(fmt, args);
	    va_end(args);
    }
 	return 0;
}
EXPORT_SYMBOL(kcjprintk);
