/* Copyright (c) 2008-2009, Code Aurora Forum. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Code Aurora Forum nor
 *       the names of its contributors may be used to endorse or promote
 *       products derived from this software without specific prior written
 *       permission.
 *
 * Alternatively, provided that this notice is retained in full, this software
 * may be relicensed by the recipient under the terms of the GNU General Public
 * License version 2 ("GPL") and only version 2, in which case the provisions of
 * the GPL apply INSTEAD OF those given above.  If the recipient relicenses the
 * software under the GPL, then the identification text in the MODULE_LICENSE
 * macro must be changed to reflect "GPLv2" instead of "Dual BSD/GPL".  Once a
 * recipient changes the license terms to the GPL, subsequent recipients shall
 * not relicense under alternate licensing terms, including the BSD or dual
 * BSD/GPL terms.  In addition, the following license statement immediately
 * below and between the words START and END shall also then apply when this
 * software is relicensed under the GPL:
 *
 * START
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License version 2 and only version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * END
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

#include "s5k4eag.h"

#define  S5K4EAG_HWVER_REG_GC       0x0000
#define  S5K4EAG_REVVER_REG_GC      0x0000

/* Write Initial Setting */
struct s5k4eag_i2c_reg_conf
s5k4eag_init_reg_settings_array_gc[] = {
{ 0xFCFC, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x0028, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0012, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1030, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0014, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x00A0, WORD_LEN, 100 },     /* GC */ /* Delay 100ms */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x3370, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xB538, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xA016, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x6800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x9000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2101, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0309, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x466B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x881A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4813, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8442, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x885A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8482, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2200, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x84C2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8501, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4911, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4811, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2401, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF99E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0022, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4910, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4810, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2502, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF998, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x002A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x490F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x480F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2403, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF992, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0022, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x490E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x480E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2504, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF98C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x490D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x480E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x002A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF987, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xBC38, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xBC08, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4718, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4EAC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1D64, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3479, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xA06F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3511, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3769, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x35FD, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x04C5, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x33FD, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x20FD, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x34D5, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7C4F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xB4F0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4895, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4995, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8980, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8008, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4C97, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4D95, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8B63, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2601, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8B24, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4992, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x892A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2801, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2802, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD104, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4F8E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3F60, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x797F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD015, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2C00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD007, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2803, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD005, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2804, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4C8C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8026, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4C8C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8026, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2B00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD007, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4B8B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8818, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0852, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0052, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x812A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x804A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4310, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8018, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xBCF0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4770, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4887, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x88C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD1F9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2C00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4C81, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4C81, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2B00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD0F1, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0010, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4330, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8128, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8048, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE7EC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xB570, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4C7F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x208B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x20C8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF92F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x80A0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8A21, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4B7B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4D7C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2900, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4A7B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8812, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2A00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD00B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2101, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03C9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8069, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x80E9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x80A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8128, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x43C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8558, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xBC70, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xBC08, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4718, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8069, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x80A0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8A20, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x80E8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2002, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x80A0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8A20, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x80A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x80A0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8A20, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8128, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x486E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8558, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE7EC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xB5F8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4C6D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x680D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x486D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF90A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4E6C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4F66, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0041, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x198A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x88D2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4362, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A92, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2302, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2A02, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD900, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0013, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1AE2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x19CB, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x33FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3341, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x809A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x526A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1C40, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2803, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD3ED, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xBCF8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xBC08, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4718, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xB5F8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4852, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4D60, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3860, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x79C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4E60, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2802, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD128, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4F5E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2401, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3FE0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x833C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x485D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x6FC1, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF8E9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x485C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x6941, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x485C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x69C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1A08, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF8EA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF8F0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x69E9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF8DC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4857, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4958, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8148, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4944, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3940, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x89C8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x88C8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8130, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4953, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3920, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x83C8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x83BC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x83F8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1E40, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8130, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE7CB, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x484A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x494E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1844, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x230D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x071B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8818, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4A4D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8010, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8958, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8810, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2108, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4308, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8010, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8898, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4949, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8008, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x88D8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4948, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8008, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4F30, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3F40, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8A38, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF8C3, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4845, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4934, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8048, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x69E9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF8A4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x88F8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4937, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x39E0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8348, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8938, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x80B0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8978, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8130, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x81F0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x20CD, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8070, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1E64, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD1FD, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x483B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2203, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x6801, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8935, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0067, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0013, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x40BB, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x432B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8133, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1E40, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD2FD, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1C64, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2C08, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xDBF3, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF8A5, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE786, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xB5F8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2601, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0035, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3810, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4086, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x40A5, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4F2F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2C10, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xDA03, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8838, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x43A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8038, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE002, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8878, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x43B0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8078, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF898, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2C10, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xDA03, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8838, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4328, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8038, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE002, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8878, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4330, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8078, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x480B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3840, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8A00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD008, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4C10, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4920, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8860, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4288, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD103, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF88B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4820, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8060, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE75A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02B8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1AAC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1FB8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x169C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x070C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x6100, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x6600, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x6200, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2CC0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xA000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1D64, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2338, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3774, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x9999, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x24B4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1094, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0140, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0140, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2968, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2254, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1FFF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2710, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0570, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0572, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0574, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xABCD, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x005C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1100, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xDCBA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x16D7, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF193, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7C49, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x29AF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4DE3, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1147, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x21B5, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x36DB, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x04C5, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x21F9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0028, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1030, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1030, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1030, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1030, WORD_LEN, 100 },     /* GC */ /* Delay 100ms */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x023E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x024C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x200C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0320, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x023C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0244, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0031, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0716, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00FF, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02CC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00E9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0200, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0238, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x018C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x016C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00E6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0132, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x159C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x641E, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x15B2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0022, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0026, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x002A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x002E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0032, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0036, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0046, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x004A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x004E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0052, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0055, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0058, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x005B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x005E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0061, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0064, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1606, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00C0, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x16B2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1610, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x15A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0302, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x161A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x15B0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0013, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x169C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0010, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1660, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF95, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1748, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0010, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000A, WORD_LEN, 100 },     /* GC */ /* Delay 100ms */
{ 0x0028, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF404, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x002A, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF46E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F02, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF45A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF40E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF40C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF420, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0027, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF426, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00D4, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF460, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xE304, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0081, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xE308, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0081, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xE506, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0093, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xE402, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x040C, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF42A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF408, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0007, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF400, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0007, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF43C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF440, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0024, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF444, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0040, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF452, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF45C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF406, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF410, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF472, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x005C, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF476, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x008A, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0xF470, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GC */
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1940, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0007, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1954, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x005C, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18C4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3B00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x3B00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05FA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05FC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05FC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0014, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05FC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0014, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05FC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0258, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0258, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0258, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05FA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0260, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x008C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x009E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05FA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02B2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05FA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00D8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01C8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02E4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01DB, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x020F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0219, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0223, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01EC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x020F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01D6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05FA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00D4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02E0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05F8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0609, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18C8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3C00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x3C00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x081E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0414, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x040F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0014, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x040F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0422, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0146, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01D0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0554, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05DE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01D0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0410, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05DE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x081E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0144, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0414, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0552, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0144, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01D8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0552, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05E6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x008C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x040F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x049A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x009E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x040F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x04AC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0144, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x040F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0552, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0410, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x04B4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x081E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x022A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0410, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0638, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x081E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00D8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0140, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0292, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x040A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x04E6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x054E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x06A0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0818, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0142, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x016E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x040C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0438, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0550, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x057C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x014D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0182, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x018C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0196, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0417, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x044C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0456, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0460, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x055B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0590, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x059A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05A4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0158, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0182, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0422, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x044C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0566, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0590, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0146, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x014E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0410, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0418, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0554, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x055C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x081E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x082A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00D4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0144, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x028E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x040E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x04E2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0552, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x069C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x081C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0146, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0410, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0554, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0830, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 100 },     /* GC */ /* Delay 100ms */
{ 0x002A, 0x023E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x024C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x200C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0320, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x023C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0244, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0031, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0716, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00FF, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02CC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00E9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0200, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0238, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x018C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x016C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00E6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0132, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x15B2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0040, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0045, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x004A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x004F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0054, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0059, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x006E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0073, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0078, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x007C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0082, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0087, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x008C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0091, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0096, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x009B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00A0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00A5, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00AA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00AE, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x16B2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1610, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1002, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x15A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0302, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x161A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x15B0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0014, WORD_LEN, 100 },     /* GC */  /* Delay 100ms */
{ 0x002A, 0x08B8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x08CE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00A2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0DB8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xB057, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xCAFD, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1AB1, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02E2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFAD6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x006D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xB129, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F28, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0B78, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xDE4B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x154F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00ED, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x41BD, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFACD, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE5E1, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x246B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x040D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE17E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xCF6B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF9A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1D29, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE014, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF904, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1FD3, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x27A9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0439, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03DE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF77, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF9B6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF2C2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x016E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE2F9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1CFD, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03E3, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF021, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD4CE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xBAAF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2E73, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xEB7C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x16A9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xEEE6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x9703, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1125, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF61, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFA29, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE92E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2543, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5608, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFC9B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xEF63, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x10BF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x25E4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xBD67, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xC931, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF1E2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1420, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE5BD, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF4AD, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x34AA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x200B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x13D5, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0DB9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFDEF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xEBB8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF9A0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00AC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xEFD5, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE3B8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1764, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1576, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xECE9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xA640, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xC627, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x27B2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xEC4F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x11D8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF4AB, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xB77D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x189F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF88, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xEBEA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0891, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0811, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3DC2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF1A7, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE711, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2E50, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF78B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE501, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD6A1, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF1D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2358, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD02E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0330, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2382, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x202D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0531, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF671, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0881, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x011B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF1E4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF3EB, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFA2F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF6E8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F36, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x04BF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF3DE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xB21A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xC47C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x24AC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF4C3, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x08D3, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF96A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xAF42, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1752, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFF8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xEAC4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A61, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x06B4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x48D4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xECDC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF1C7, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x22BE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFEB1, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xE48A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xCE99, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0755, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1096, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xDF73, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFB9E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x246D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x21F3, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFE83, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x076C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0426, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF0B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF042, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF785, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFD99, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xEE4F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0AA9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0CA0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xF4A6, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x08C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00CB, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00B1, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0111, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0159, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0195, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01B0, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x08EE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4B86, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4B86, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3993, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3C3F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x44FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3700, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x400F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x400F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x491B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x08EA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02B4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x053E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1498, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003A, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x149E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x05C8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5DC0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x08B4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x08B4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x71E8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0280, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0600, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0580, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0111, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00EF, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x14A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0303, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0303, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0303, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0303, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0503, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0305, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0501, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0105, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0201, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0504, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0405, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0102, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0402, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0204, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0202, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0202, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0201, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0102, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x2A14, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0520, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1788, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x018E, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x17CE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x04C4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0055, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0055, WORD_LEN, 0 },       /* GC */
{ 0x0028, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x00A0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0238, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5DC0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0252, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x025A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x445C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x445C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x445C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5DC0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 100 },     /* GC */ /* Delay 100ms */
{ 0x002A, 0x02E8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0500, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02F6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02FE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0535, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0312, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0318, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0500, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0326, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x032E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A6B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0342, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0348, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0500, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x445C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x445C, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0356, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x035E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0535, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0372, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0378, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0320, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0258, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0386, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x038E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0149, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0149, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x03A2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02C2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1888, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0546, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0999, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18AA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0999, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18AE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x020B, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18A4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18AC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0260, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x03D8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x03DC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A20, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0798, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0009, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x03EA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0048, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0960, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x03F6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x03F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x03F8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0535, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0300, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x040A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A20, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0798, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0009, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0418, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0048, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0960, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A6A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0300, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02AA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02B0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 10 },      /* GC */ /* Delay 10ms */
{ 0x002A, 0x0820, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0730, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0050, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x006E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00DC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x014A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0178, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0191, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01BC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01E2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0204, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0224, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x025E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0292, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02ED, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x033C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0383, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03C4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0050, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x006E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00DC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x014A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0178, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0191, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01BC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01E2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0204, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0224, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x025E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0292, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02ED, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x033C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0383, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03C4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0050, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x006E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00DC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x014A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0178, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0191, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01BC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01E2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0204, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0224, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x025E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0292, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02ED, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x033C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0383, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03C4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x10A4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x038C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03E2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0354, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03BA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x031C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0394, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02E4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x036E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02C2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0354, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02A4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x033C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0286, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0320, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0266, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0306, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0244, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02E8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0224, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02CA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0204, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02AC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01E0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x028C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01D4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x026E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01C6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x024E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01B8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0236, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01AA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0220, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01B6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x020C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0012, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00E6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x025E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0264, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0242, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x027C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0236, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0288, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0232, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0288, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0230, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0284, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0232, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x027C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0236, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0274, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x026A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01FC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x032A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0438, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0284, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0406, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0232, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03D8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01E6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03A4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01AE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0344, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x017C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02F8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x014E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02B8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0126, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x027C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x023C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00DC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x020C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0006, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0102, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0350, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x013C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xA5C4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x020E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0232, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01E0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x023A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01B8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x021C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x019A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01FE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x017C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01E0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x015C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01C6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0144, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01AE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0130, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0194, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x011C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x017A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0108, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0162, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x024A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x11C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0270, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0290, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0210, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0272, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01FC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0236, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01DC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0218, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01BE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01FC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01A0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01DC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x017C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01BE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0007, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0160, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x11FC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x033E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x035A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0320, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x033E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0302, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0320, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02DE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0302, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02BC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02E4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0294, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02BC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0270, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0298, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x024E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0276, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0132, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x123C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0124, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x011B, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1256, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x059F, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x125C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0425, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x033B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0400, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0016, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1270, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0032, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1282, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1500, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x006A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0055, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x55BF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5556, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05AA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xABFF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4006, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xAAAB, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF40, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x17FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFFF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x502F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFFF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF54, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x6FFF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFFF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF01, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x13AF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x015D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0096, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1480, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x252A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0010, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00C0, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x08B6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x089C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x3F00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0167, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFAE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFC0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFAB, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x016A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFE68, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0037, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x005B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x029C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01C4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00E2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFED5, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0170, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF9D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0275, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFE82, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01B6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0167, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFAE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFC0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFAB, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x016A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFE68, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0037, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x005B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x029C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01C4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00E2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFED5, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0170, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF9D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0275, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFE82, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01B6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x022A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFB2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFFA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFEFE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x018B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFEF5, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFD6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFF2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01B6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0109, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00EE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF3E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0244, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF75, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01AF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF1F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x022A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFB2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFFA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFEFE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x018B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFEF5, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFD6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFF2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01B6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0109, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00EE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF3E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0244, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF75, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01AF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF1F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CB, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFDC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFEED, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x012C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF65, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0013, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFFF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00EB, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF91, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF60, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x014E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFEF9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0120, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00CD, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CB, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFDC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFEED, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x012C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF65, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0013, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFFF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00EB, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF91, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF60, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x014E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFEF9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0120, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00CD, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x08A4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3FD8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x3FD8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CB, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFDC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFEED, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x012C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF65, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0013, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFFFF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00EB, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF91, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF60, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x014E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFEF9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0120, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00CD, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x08AA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00D3, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00EC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00D9, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0125, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0159, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0182, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F0, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x1A5A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x093C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0056, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00A7, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0151, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x02A3, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0980, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x005F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x005F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00CF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0050, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0155, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0060, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0060, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0032, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0032, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1004, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1010, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0010, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5050, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x7850, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x6478, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0064, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5A00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A06, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0028, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0700, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0808, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0400, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0C04, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A0C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x200A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0408, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A04, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1414, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3205, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x041E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3200, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2808, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1E00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1E1E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1B1E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1400, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0200, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0300, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0909, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0909, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1202, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0608, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0201, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x090F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0202, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0C60, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0010, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0891, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x005F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x005F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00CF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0050, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0155, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0060, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0060, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0032, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0032, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1004, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1010, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0010, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5050, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5050, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x4B50, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x004B, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5A00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A06, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0028, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0700, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0808, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0400, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0C04, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A0C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x200A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0408, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A04, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1414, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3205, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x041E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3200, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2808, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1E00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1E1E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1B1E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1400, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0200, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0300, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0909, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0909, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1202, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0608, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0201, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0202, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0202, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0010, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0891, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x001D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x005F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x005F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00CF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0050, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0155, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0060, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0060, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0032, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0032, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2004, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5050, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3C50, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x323C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0032, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5A00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A06, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0028, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0700, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0808, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0400, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0C04, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A0C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x200A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0408, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A04, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1414, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3205, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x041E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3200, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2808, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1E00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1E1E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1B1E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1400, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0200, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0300, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0909, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0909, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1202, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0608, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0201, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0202, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0202, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0010, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0891, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x001D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x005F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x005F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00CF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0050, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0155, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0060, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0060, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0032, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0032, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2004, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0808, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0108, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5050, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3250, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2832, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0028, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5A00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A06, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0028, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0700, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0808, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0400, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0C04, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A0C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x200A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0408, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A04, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1414, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3205, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x041E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3200, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2808, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1E00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1E1E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1B1E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1400, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0200, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0300, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0909, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0909, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1202, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0608, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0201, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0202, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0202, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0010, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0891, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x001D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x000A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00C0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x005F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x005F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x00CF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0050, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0155, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0060, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0060, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0032, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0032, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2004, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0808, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0108, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5050, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1E50, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1E1E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x021E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xFF02, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x5A00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1406, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0014, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0700, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0808, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0400, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0C04, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A0C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x200A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0408, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A04, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1414, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3205, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x041E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x3200, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2808, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1E00, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1E1E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1B1E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0900, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0200, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0300, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0909, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0909, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x1202, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0608, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0201, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0202, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0202, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0800, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x8080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0010, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0891, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x001D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xD74E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x49BA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0xC020, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x6F7A, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x07C2, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0028, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x7214, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0018, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x003E, WORD_LEN, 100 },     /* GC */ /* Delay 100ms */
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02C4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 300 },     /* GC */ /* Delay 300ms */
{ 0x002A, 0x02C4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x147C, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
};

/* ***** Preview1 Normal ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview1_normal_reg_settings_array_gc[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02AA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
};
/* ***** Preview1 Normal ***** */

/* ***** Preview1 Night ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview1_night_reg_settings_array_gc[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02AA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
};
/* ***** Preview1 Night ***** */

/* ***** Preview2 Normal ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview2_normal_reg_settings_array_gc[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0364, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0535, WORD_LEN, 0 },       /* GC *//* FrameRateC 20100121 */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0546, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0540, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18A4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18AC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0260, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02AA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
};
/* ***** Preview2 Normal ***** */

/* ***** Preview2 Night ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview2_night_reg_settings_array_gc[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0364, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A6B, WORD_LEN, 0 },       /* GC *//* FrameRateC 20100121 */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0546, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0540, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18A4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18AC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0260, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02AA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
};
/* ***** Preview2 Night ***** */

/* ***** Preview2 Fix ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview2_fix_reg_settings_array_gc[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0364, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0546, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0540, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18A4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18AC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0260, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02AA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
};
/* ***** Preview2 Fix ***** */

/* ***** Preview3 Normal ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview3_normal_reg_settings_array_gc[] = {
{ 0xFCFC, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0394, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0535, WORD_LEN, 0 },       /* GC *//* FrameRateC 20100121 */
{ 0x0F12, 0x014D, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0546, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0540, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18A4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18AC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0260, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02AA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
};
/* ***** Preview3 Normal ***** */

/* ***** Preview3 Night ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview3_night_reg_settings_array_gc[] = {
{ 0xFCFC, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0394, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0A6B, WORD_LEN, 0 },       /* GC *//* FrameRateC 20100121 */
{ 0x0F12, 0x014D, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0546, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0540, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18A4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18AC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0260, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02AA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
};
/* ***** Preview3 Night ***** */

/* ***** Preview3 Fix ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview3_fix_reg_settings_array_gc[] = {
{ 0xFCFC, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0394, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x014D, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x014D, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0546, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0540, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18A4, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x18AC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0260, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02AA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
};
/* ***** Preview3 Fix ***** */

/* ***** Jpeg Still Normal ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_still_normal_reg_settings_array_gc[] = {
{ 0xFCFC, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02AE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0282, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0284, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02B0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
};
/* ***** Jpeg Still Normal ***** */

/* ***** Jpeg Still Night ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_still_night_reg_settings_array_gc[] = {
{ 0xFCFC, 0xD000, WORD_LEN, 0 },       /* GC */
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02AE, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0282, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0284, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02B0, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
};
/* ***** Jpeg Still Night ***** */

/* ***** Jpeg Still Flash ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_still_flash_reg_settings_array_gc[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x04C8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x16F8, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02AA, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0282, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x0284, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
{ 0x002A, 0x02AC, WORD_LEN, 0 },       /* GC */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GC */
};
/* ***** Jpeg Still Flash ***** */

struct s5k4eag_reg_t s5k4eag_regs_gc = {
  .hw_ver_addr = S5K4EAG_HWVER_REG_GC,
  .rev_ver_addr = S5K4EAG_REVVER_REG_GC,
  
  /* Init Registers */
	.init_reg_settings = &s5k4eag_init_reg_settings_array_gc[0],
	.init_reg_settings_size =
		ARRAY_SIZE(s5k4eag_init_reg_settings_array_gc),
  
  /* Preview1 Normal 4VGA */
  .preview1_normal_reg_settings = &s5k4eag_preview1_normal_reg_settings_array_gc[0],
  .preview1_normal_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview1_normal_reg_settings_array_gc),
  /* Preview1 Night 4VGA */
  .preview1_night_reg_settings = &s5k4eag_preview1_night_reg_settings_array_gc[0],
  .preview1_night_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview1_night_reg_settings_array_gc),
  
  /* Preview2 720p(4VGA) 24fps(Normal) */
  .preview2_normal_reg_settings = &s5k4eag_preview2_normal_reg_settings_array_gc[0],
  .preview2_normal_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview2_normal_reg_settings_array_gc),
  /* Preview2 720p(4VGA) 24fps(Night) */
  .preview2_night_reg_settings = &s5k4eag_preview2_night_reg_settings_array_gc[0],
  .preview2_night_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview2_night_reg_settings_array_gc),
  /* Preview2 720p(4VGA) 24fps(Fixed) */
  .preview2_fix_reg_settings = &s5k4eag_preview2_fix_reg_settings_array_gc[0],
  .preview2_fix_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview2_fix_reg_settings_array_gc),
  
  /* Preview3 FVGA 30fps(Normal) */
  .preview3_normal_reg_settings = &s5k4eag_preview3_normal_reg_settings_array_gc[0],
  .preview3_normal_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview3_normal_reg_settings_array_gc),
  /* Preview3 FVGA 30fps(Night) */
  .preview3_night_reg_settings = &s5k4eag_preview3_night_reg_settings_array_gc[0],
  .preview3_night_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview3_night_reg_settings_array_gc),
  /* Preview3 FVGA 30fps(Fixed) */
  .preview3_fix_reg_settings = &s5k4eag_preview3_fix_reg_settings_array_gc[0],
  .preview3_fix_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview3_fix_reg_settings_array_gc),
  
  /* Jpeg Still Normal */
  .still_normal_reg_settings = &s5k4eag_still_normal_reg_settings_array_gc[0],
  .still_normal_reg_settings_size =
		ARRAY_SIZE(s5k4eag_still_normal_reg_settings_array_gc),
  /* Jpeg Still Night */
  .still_night_reg_settings = &s5k4eag_still_night_reg_settings_array_gc[0],
  .still_night_reg_settings_size =
		ARRAY_SIZE(s5k4eag_still_night_reg_settings_array_gc),
  /* Jpeg Still Flash */
  .still_flash_reg_settings = &s5k4eag_still_flash_reg_settings_array_gc[0],
  .still_flash_reg_settings_size =
		ARRAY_SIZE(s5k4eag_still_flash_reg_settings_array_gc),
  
};
