/* Copyright (c) 2008-2009, Code Aurora Forum. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Code Aurora Forum nor
 *       the names of its contributors may be used to endorse or promote
 *       products derived from this software without specific prior written
 *       permission.
 *
 * Alternatively, provided that this notice is retained in full, this software
 * may be relicensed by the recipient under the terms of the GNU General Public
 * License version 2 ("GPL") and only version 2, in which case the provisions of
 * the GPL apply INSTEAD OF those given above.  If the recipient relicenses the
 * software under the GPL, then the identification text in the MODULE_LICENSE
 * macro must be changed to reflect "GPLv2" instead of "Dual BSD/GPL".  Once a
 * recipient changes the license terms to the GPL, subsequent recipients shall
 * not relicense under alternate licensing terms, including the BSD or dual
 * BSD/GPL terms.  In addition, the following license statement immediately
 * below and between the words START and END shall also then apply when this
 * software is relicensed under the GPL:
 *
 * START
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License version 2 and only version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * END
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

#include "s5k4eag.h"

#define  S5K4EAG_HWVER_REG_GX1       0x0000
#define  S5K4EAG_REVVER_REG_GX1      0x0000

/* Write Initial Setting */
struct s5k4eag_i2c_reg_conf
s5k4eag_init_reg_settings_array_gx1[] = {
{ 0x0028, 0xD000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0012, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x1030, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0014, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x00A0, WORD_LEN, 100 },     /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x31A4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xB538, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xA013, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x6800, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x9000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x466B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8819, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4811, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8441, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8859, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8481, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2200, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x84C2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2105, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8501, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x490E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x480F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2401, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF947, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0022, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x490D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x480E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2502, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF941, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x002A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x490C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x480D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2403, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF93B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x490C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x480C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0022, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF936, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xBC38, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xBC08, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4718, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4EA2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00A2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1C18, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3215, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x9E1B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3271, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3569, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x335F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x04C5, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x33B5, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x79FB, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xB570, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4C75, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x208B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8020, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x20C8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF91F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x80A0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8A21, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4B71, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4D72, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2900, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD003, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4A71, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8812, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2A00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD00B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2101, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03C9, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8069, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x80E9, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x80A8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8128, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x43C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8558, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xBC70, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xBC08, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4718, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8069, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x80A0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8A20, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x80E8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2002, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x80A0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8A20, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x80A8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2003, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x80A0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8A20, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8128, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4864, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8558, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE7EC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xB5F8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4863, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4D63, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x79C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4E63, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2802, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD129, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4F62, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2401, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3FE0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x833C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4861, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x6FC1, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF8F0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x485F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x6941, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x485F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x6900, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1A08, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF8F1, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF8F7, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x69E9, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF8E3, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x485B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x495B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8148, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x495B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x89C8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x88C8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8130, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4957, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3920, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x83C8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x83BC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x83F8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1E40, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8130, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xBCF8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xBC08, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4718, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x484D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3020, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8800, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4952, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1844, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x230D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x071B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8818, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4A51, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8010, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8958, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD003, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8810, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2108, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4308, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8010, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8898, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x494D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8008, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x88D8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x494C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8008, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4F47, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8A38, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF8CA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4849, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x493A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8048, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x69E9, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF8AB, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF8B9, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x88F8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4939, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x39E0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8348, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8938, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x80B0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8978, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8130, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x81F0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x20CD, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8070, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1E64, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD1FD, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x483F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2203, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x6801, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8935, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0067, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0013, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x40BB, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x432B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8133, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1E40, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD2FD, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1C64, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2C08, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xDBF3, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF8AA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE7B6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xB5F8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2601, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0035, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3810, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4086, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x40A5, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4F33, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2C10, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xDA03, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8838, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x43A8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8038, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE002, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8878, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x43B0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8078, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF89D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2C10, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xDA03, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8838, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4328, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8038, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE002, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8878, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4330, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8078, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4821, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8A00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD008, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4C15, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4924, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8860, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4288, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD103, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF891, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4824, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8060, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE78B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xB5F8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4C23, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x680D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4823, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF890, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4E22, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4F0B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0041, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x198A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x88D2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4362, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A92, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2302, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2A02, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD900, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0013, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1AE2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x19CB, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x33FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3341, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x809A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x526A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1C40, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2803, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD3ED, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE76F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xA000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1C18, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x21D0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x34F0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x9999, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1E10, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0140, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0140, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2108, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1FFF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1080, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x06E8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2710, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0560, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0562, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0564, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xABCD, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x005C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1100, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xDCBA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x234C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0FC4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1097, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xEE47, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x226F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4BE3, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0B3F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1A75, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x34DB, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x04C5, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1AB9, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x79F5, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0028, 0xD000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x1000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x1030, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x1000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x1030, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x1000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x1030, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 10 },      /* GX1 */
{ 0x002A, 0xF468, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0006, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF404, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x002A, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF46E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF45A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF40E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF40C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF420, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0076, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF426, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00D4, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF460, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xE304, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0081, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xE308, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0081, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xE506, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0093, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xE402, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x040C, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF42A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF408, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0007, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF400, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0007, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF43C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF440, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0044, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF444, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF448, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF45C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF406, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF410, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF472, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x005C, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0xF470, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1 */
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x17CC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3BB0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x3BB0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05BA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05BC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05BC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0014, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05BC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0014, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05BC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01AE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0238, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01AE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0238, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0238, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05BA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01AC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01AC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0240, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x008C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x009E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01AC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00A6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05BA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0292, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05BA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00D8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01A8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x02C4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05B4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01AA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01D6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01BB, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01EF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01F9, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0203, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01CC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01EF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01AE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01B6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05BA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05C6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00D4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01AC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x02C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05B8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01AE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x17D0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3C8A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x3C8A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x081E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0414, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x040F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0014, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x040F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0422, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0146, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01D0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0554, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05DE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01D0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0410, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05DE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x081E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0144, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0414, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0552, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0144, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01D8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0552, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05E6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x008C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x040F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x049A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x009E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x040F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x04AC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0144, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x040F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0552, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00A6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0410, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x04B4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x081E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x022A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0410, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0638, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x081E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00D8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0140, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0292, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x040A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x04E6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x054E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x06A0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0818, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0142, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x016E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x040C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0438, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0550, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x057C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x014D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0182, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x018C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0196, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0417, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x044C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0456, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0460, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x055B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0590, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x059A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05A4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0158, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0182, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0422, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x044C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0566, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0590, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0146, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x014E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0410, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0418, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0554, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x055C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x081E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x082A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00D4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0144, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x028E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x040E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x04E2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0552, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x069C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x081C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0146, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0410, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0554, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0830, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x023E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0003, WORD_LEN, 100 },     /* GX1 */
{ 0x002A, 0x023C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0240, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0031, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x024C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x200C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0320, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02C6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00E3, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0200, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0238, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x018C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0166, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00E6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0132, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x06BE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00FF, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x15DA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x1550, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1002, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x155A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x14E8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0302, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x14F0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0011, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0030, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0035, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0039, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0040, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0045, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0049, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x004C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0055, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0059, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x005C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0065, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0069, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x006C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0075, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x007F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0086, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x008D, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x14E2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1104, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x13C8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x003A, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x13CE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0590, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7D00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3880, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7D00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3880, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0280, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0600, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0574, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0111, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00EF, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x13D6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0303, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0303, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0303, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0303, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0503, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0305, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0501, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0105, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0201, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0504, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0405, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0102, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0402, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0204, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0202, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0202, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0201, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0102, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0534, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x075F, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x051A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x1690, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x018E, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x16D6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x04C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0055, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0238, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x5DC0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0252, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x025A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1 *//* PCLK 56Mhz FIX*/
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1 *//* PCLK 56Mhz FIX*/
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1 *//* PCLK 56Mhz FIX*/
{ 0x0F12, 0x445C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x445C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x445C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x5DC0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1 *//* PCLK 56Mhz FIX*/
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1 *//* PCLK 56Mhz FIX*/
{ 0x002A, 0x026E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0540, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x053A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x17B2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x17B6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x17BA, WORD_LEN, 100 },     /* GX1 */
{ 0x0F12, 0x0260, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02E2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0500, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1 *//* PCLK 56Mhz FIX*/
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1 *//* PCLK 56Mhz FIX*/
{ 0x002A, 0x02F0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02F8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0535, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x030C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0312, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0500, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1 *//* PCLK 56Mhz FIX*/
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1 *//* PCLK 56Mhz FIX*/
{ 0x002A, 0x0320, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0328, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A6B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x033C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0342, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0500, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x445C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x445C, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0350, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0358, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0535, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x036C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0372, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0320, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0258, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1 *//* PCLK 56Mhz FIX*/
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1 *//* PCLK 56Mhz FIX*/
{ 0x002A, 0x0380, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0388, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0149, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0149, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x039C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x03D6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A20, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0798, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0009, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1 *//* PCLK 56Mhz FIX*/
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1 *//* PCLK 56Mhz FIX*/
{ 0x002A, 0x03E4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x03E8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0960, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0535, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0140, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0404, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A20, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0798, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0009, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1 *//* PCLK 56Mhz FIX*/
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1 *//* PCLK 56Mhz FIX*/
{ 0x002A, 0x0412, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0416, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0960, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A6A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0290, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0280, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x06D8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0050, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x006E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00DC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x014A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0178, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0191, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01BC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01E2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0204, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0224, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x025E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0292, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x02ED, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x033C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0383, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03C4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0050, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x006E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00DC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x014A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0178, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0191, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01BC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01E2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0204, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0224, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x025E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0292, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x02ED, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x033C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0383, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03C4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0050, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x006E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00DC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x014A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0178, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0191, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01BC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01E2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0204, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0224, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x025E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0292, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x02ED, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x033C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0383, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03C4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0860, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0876, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00A2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0C72, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0E00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xBF58, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x490F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x427F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x288D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xEF67, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xEFBD, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4BA1, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0445, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x722F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xEC3C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x416E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xDE94, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0BCC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xBD5C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x6945, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xCFEB, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xB380, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC308, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC0FB, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1B48, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x54E6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF1C4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7EC0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xAF01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x07C4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x68FB, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF804, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x789C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xAD70, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF5E6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x9747, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1A0C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2634, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01FC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7F2C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8FA6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xCFA0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x47DD, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2DF6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x5FA3, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xA72A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1CD2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x42C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF925, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xA38B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8345, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC486, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8F8C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x10F1, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xCC8C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2C10, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x44B7, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3284, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x06C8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC202, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x11D6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x6DEF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD020, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8CEC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xB901, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x6C08, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x07E5, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x5475, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE0C2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xCEB3, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x9DDB, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1764, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1B01, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x09B6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x89D1, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x80AD, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xAC81, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x58E7, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2243, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x5BAD, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xB9A4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0B87, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x596D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF242, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x9DE8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xA63D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8578, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xBF61, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0773, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xCE24, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3504, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x21E3, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x71E1, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD55F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xB9E5, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x195B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7E50, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xAD9A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x998B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC75E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1625, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x5890, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE021, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xA7B7, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xBAD1, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xB5DC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8D7D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x28A0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x34B8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xDFA9, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7A23, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xB98B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xB5EB, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x5C8C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1B8C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x680D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xA8D5, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1864, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x5994, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE596, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xAE03, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x9831, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x9002, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xB7A8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFBB0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xE13A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2300, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2056, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x86F0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC74A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xCD28, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x02E9, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x9195, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xB203, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x82F8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD116, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x083E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x68C6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD1D6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xB4F6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x9C5C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xDDB8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x9086, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x256F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3532, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xD26C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xA9E6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x83DB, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0892, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0538, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0F84, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0336, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x038A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x02FC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0388, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x02DC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x036E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x02BC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0354, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x02A0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x033A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0280, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0320, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x025E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0302, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x023E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x02E4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x021C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x02C4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01FA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x02A6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01EE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0286, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01E0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0268, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01D2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x024E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01C4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x023A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01D0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0226, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01E4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0212, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0FD8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0011, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0FDC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x013C, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0FE0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x025E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0264, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0242, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x027C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0236, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0288, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0232, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0288, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0230, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0284, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0232, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x027C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0236, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0274, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0252, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x026A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01FC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x034D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x045B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x02EA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0445, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x02A4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0428, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0254, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03FB, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0207, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03C7, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01CF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0365, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x019E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x031A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0170, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x02DB, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0149, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x029E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0122, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x025D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00FE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x022E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00E4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01F1, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0006, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x1050, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000C, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x1054, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00D6, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x111C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x012D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x012E, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x1136, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0565, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x113C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0680, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0338, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0023, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0019, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x1150, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0032, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x1164, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1500, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x006A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0055, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x55BF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x5556, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05AA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xABFF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4006, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xAAAB, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF40, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x17FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFFF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x502F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFFF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF54, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x6FFF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFFF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFEF7, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0021, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2139, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0297, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7FFF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00DF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000E, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x13B4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x23CA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00C0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0010, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00C0, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0844, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x3F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0231, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFD8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFF0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFA2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01C1, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFE1A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFD7, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFC1, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01E7, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x024F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0075, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFEB8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0170, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF9D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0275, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFE78, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x017F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0231, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFD8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFF0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFA2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01C1, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFE1A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFD7, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFC1, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01E7, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x024F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0075, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFEB8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0170, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF9D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0275, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFE78, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x017F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0231, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFD8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFF0, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFA2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01C1, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFE1A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFD7, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFC1, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01E7, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x024F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0075, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFEB8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0170, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF9D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0275, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFE78, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x017F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0249, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFB9, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFF8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFEA6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0196, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF42, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFC7, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFAF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0208, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0128, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF48, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x025A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF6A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01BE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFE84, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0177, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0106, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0249, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFB9, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFF8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFEA6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0196, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF42, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFC7, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFAF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0208, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0128, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF48, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x025A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF6A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01BE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFE84, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0177, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0106, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0249, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFB9, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFF8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFEA6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0196, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF42, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFC7, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFAF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0208, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0128, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF48, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x025A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF6A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01BE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFE84, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0177, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0106, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x084C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3FD8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x3FD8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0235, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFBD, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFF8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFEDC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01A5, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF14, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFC6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF86, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0228, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x012B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF4B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0244, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF73, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01B2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFE7F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00EF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01A2, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x08E4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0086, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00A7, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00E1, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0151, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x02A3, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0928, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x005A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0040, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0019, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00D5, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00DE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03E8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0078, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF804, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8EFF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8EFF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC8FB, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xC8FA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F32, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2828, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8002, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0620, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0404, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1400, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A14, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2D0A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2080, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0408, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1008, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFFF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFFD, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1900, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4B00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x5C00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x9A00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x7C0A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x023C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F10, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A18, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0900, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0902, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0403, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0600, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0201, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1404, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0464, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x6480, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0081, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x005A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0016, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0040, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0019, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00D5, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00DE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03E8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0078, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x000A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF804, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1003, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2010, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8E32, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8E32, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x6450, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x6450, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F32, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2828, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8002, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0620, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0404, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1400, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A14, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2D0A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2080, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0808, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1008, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF1E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF19, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0604, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x191E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4B1E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0064, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2228, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3200, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x140A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x023C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F10, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A18, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0900, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0902, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0600, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0201, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1E03, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0064, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x6480, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0040, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0081, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x005A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0031, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0040, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0019, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0009, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0012, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03E8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0078, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF804, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1003, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2010, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0305, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0103, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0007, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2823, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2823, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4638, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4638, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F32, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2828, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8007, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0620, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0404, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1400, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A14, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2D0A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0880, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0808, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1008, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF1E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFF19, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0604, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x191E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4B1E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x006F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x223C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x013C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F10, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A18, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0900, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0902, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0600, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0201, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x5003, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0064, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x6480, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00F3, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x005A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x004B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0040, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0019, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0009, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0012, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03E8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0078, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF804, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1003, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2010, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x05FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0305, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0103, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0007, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2823, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2823, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3228, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3228, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F32, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2828, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8007, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0620, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0404, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1400, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A14, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2D0A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0880, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0508, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A08, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x801E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0019, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0604, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x191E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4B1E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x006F, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x113C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1E00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x013C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F10, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A18, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0900, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0903, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0800, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0106, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x5002, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8080, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0010, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00C8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00C8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0064, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0064, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00FA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01EA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03E8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0041, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0078, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0155, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0006, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0009, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0028, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xF806, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x010C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1803, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1020, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x08FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0805, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0103, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2801, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0007, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1923, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1923, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1412, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x140D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x00FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x5004, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2828, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8007, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0303, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1D1D, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0202, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A02, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x500A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0850, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0404, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A08, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1414, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1E1E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1E1E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x204C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x1028, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0802, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0408, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3008, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0630, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xA200, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0300, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0303, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0808, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0106, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x5502, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0078, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x8080, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3E1A, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xFFBF, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xBE7C, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0xB5BD, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x3C02, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0538, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02B2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02B2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02B2, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 300 },     /* GX1 */
};

/* ***** Preview1 Normal ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview1_normal_reg_settings_array_gx1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0290, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0280, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
};
/* ***** Preview1 Normal ***** */

/* ***** Preview1 Night ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview1_night_reg_settings_array_gx1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0290, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0280, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
};
/* ***** Preview1 Night ***** */

/* ***** Preview2 Normal ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview2_normal_reg_settings_array_gx1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x035E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0535, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0290, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0280, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
};
/* ***** Preview2 Normal ***** */

/* ***** Preview2 Night ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview2_night_reg_settings_array_gx1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x035E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A6B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0290, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0280, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
};
/* ***** Preview2 Night ***** */

/* ***** Preview2 Fix ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview2_fix_reg_settings_array_gx1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x035E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0290, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0280, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
};
/* ***** Preview2 Fix ***** */

/* ***** Preview3 Normal ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview3_normal_reg_settings_array_gx1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x035E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0535, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0149, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0290, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0280, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
};
/* ***** Preview3 Normal ***** */

/* ***** Preview3 Night ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview3_night_reg_settings_array_gx1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x035E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0A6B, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0149, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0290, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0280, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
};
/* ***** Preview3 Night ***** */

/* ***** Preview3 Fix ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview3_fix_reg_settings_array_gx1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x035E, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0149, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0149, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A8, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0290, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0280, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
};
/* ***** Preview3 Fix ***** */

/* ***** Jpeg Still Normal ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_still_normal_reg_settings_array_gx1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02AC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0284, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0290, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0286, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02AE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
};
/* ***** Jpeg Still Normal ***** */

/* ***** Jpeg Still Night ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_still_night_reg_settings_array_gx1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02AC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0284, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0290, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0286, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02AE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
};
/* ***** Jpeg Still Night ***** */

/* ***** Jpeg Still Flash ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_still_flash_reg_settings_array_gx1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x04CA, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x1708, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02AC, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0284, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0290, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x0286, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
{ 0x002A, 0x02AE, WORD_LEN, 0 },       /* GX1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1 */
};
/* ***** Jpeg Still Flash ***** */

#endif // #ifdef CAMSENSOR_GC1

struct s5k4eag_reg_t s5k4eag_regs_gx1 = {
  .hw_ver_addr = S5K4EAG_HWVER_REG_GX1;
  .rev_ver_addr = S5K4EAG_REVVER_REG_GX1;
  
  /* Init Registers */
	.init_reg_settings = &s5k4eag_init_reg_settings_array_gx1[0],
	.init_reg_settings_size =
		ARRAY_SIZE(s5k4eag_init_reg_settings_array_gx1),
  
  /* Preview1 Normal 4VGA */
  .preview1_normal_reg_settings = &s5k4eag_preview1_normal_reg_settings_array_gx1[0],
  .preview1_normal_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview1_normal_reg_settings_array_gx1),
  /* Preview1 Night 4VGA */
  .preview1_night_reg_settings = &s5k4eag_preview1_night_reg_settings_array_gx1[0],
  .preview1_night_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview1_night_reg_settings_array_gx1),
  
  /* Preview2 720p(4VGA) 24fps(Normal) */
  .preview2_normal_reg_settings = &s5k4eag_preview2_normal_reg_settings_array_gx1[0],
  .preview2_normal_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview2_normal_reg_settings_array_gx1),
  /* Preview2 720p(4VGA) 24fps(Night) */
  .preview2_night_reg_settings = &s5k4eag_preview2_night_reg_settings_array_gx1[0],
  .preview2_night_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview2_night_reg_settings_array_gx1),
  /* Preview2 720p(4VGA) 24fps(Fixed) */
  .preview2_fix_reg_settings = &s5k4eag_preview2_fix_reg_settings_array_gx1[0],
  .preview2_fix_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview2_fix_reg_settings_array_gx1),
  
  /* Preview3 FVGA 30fps(Normal) */
  .preview3_normal_reg_settings = &s5k4eag_preview3_normal_reg_settings_array_gx1[0],
  .preview3_normal_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview3_normal_reg_settings_array_gx1),
  /* Preview3 FVGA 30fps(Night) */
  .preview3_night_reg_settings = &s5k4eag_preview3_night_reg_settings_array_gx1[0],
  .preview3_night_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview3_night_reg_settings_array_gx1),
  /* Preview3 FVGA 30fps(Fixed) */
  .preview3_fix_reg_settings = &s5k4eag_preview3_fix_reg_settings_array_gx1[0],
  .preview3_fix_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview3_fix_reg_settings_array_gx1),
  
  /* Jpeg Still Normal */
  .still_normal_reg_settings = &s5k4eag_still_normal_reg_settings_array_gx1[0],
  .still_normal_reg_settings_size =
		ARRAY_SIZE(s5k4eag_still_normal_reg_settings_array_gx1),
  /* Jpeg Still Night */
  .still_night_reg_settings = &s5k4eag_still_night_reg_settings_array_gx1[0],
  .still_night_reg_settings_size =
		ARRAY_SIZE(s5k4eag_still_night_reg_settings_array_gx1),
  /* Jpeg Still Flash */
  .still_flash_reg_settings = &s5k4eag_still_flash_reg_settings_array_gx1[0],
  .still_flash_reg_settings_size =
		ARRAY_SIZE(s5k4eag_still_flash_reg_settings_array_gx1),
  
};

