/* Copyright (c) 2008-2009, Code Aurora Forum. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Code Aurora Forum nor
 *       the names of its contributors may be used to endorse or promote
 *       products derived from this software without specific prior written
 *       permission.
 *
 * Alternatively, provided that this notice is retained in full, this software
 * may be relicensed by the recipient under the terms of the GNU General Public
 * License version 2 ("GPL") and only version 2, in which case the provisions of
 * the GPL apply INSTEAD OF those given above.  If the recipient relicenses the
 * software under the GPL, then the identification text in the MODULE_LICENSE
 * macro must be changed to reflect "GPLv2" instead of "Dual BSD/GPL".  Once a
 * recipient changes the license terms to the GPL, subsequent recipients shall
 * not relicense under alternate licensing terms, including the BSD or dual
 * BSD/GPL terms.  In addition, the following license statement immediately
 * below and between the words START and END shall also then apply when this
 * software is relicensed under the GPL:
 *
 * START
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License version 2 and only version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * END
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

#include "s5k4eag.h"

#define  S5K4EAG_HWVER_REG_GX1_1       0x0000
#define  S5K4EAG_REVVER_REG_GX1_1      0x0000

/* register table: 20100204 */
/* Write Initial Setting */
struct s5k4eag_i2c_reg_conf
s5k4eag_init_reg_settings_array_gx1_1[] = {
{ 0xFCFC, 0xD000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0028, 0xD000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0012, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x1030, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0014, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x00A0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 10 },      /* GX1_1 *//* Wait 10ms */
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x319C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xB538, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xA013, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x6800, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x9000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x466B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8819, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4811, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8441, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8859, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8481, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2200, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x84C2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2105, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8501, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x490E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x480F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2401, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF947, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0022, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x490D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x480E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2502, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF941, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x002A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x490C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x480D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2403, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF93B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x490C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x480C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0022, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF936, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xBC38, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xBC08, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4718, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4EA2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00A2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1C18, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3215, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x9E1B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3271, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3569, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x335F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x04C5, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x33B5, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x79FB, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xB570, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4C75, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x208B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8020, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x20C8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF91F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x80A0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8A21, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4B71, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4D72, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2900, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4A71, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8812, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2A00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD00B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2101, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03C9, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8069, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x80E9, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x80A8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8128, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x43C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8558, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xBC70, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xBC08, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4718, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8069, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x80A0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8A20, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x80E8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x80A0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8A20, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x80A8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x80A0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8A20, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8128, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4864, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8558, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE7EC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xB5F8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4863, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4D63, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x79C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4E63, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2802, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD129, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4F62, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2401, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3FE0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x833C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4861, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x6FC1, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF8F0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x485F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x6941, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x485F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x6900, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1A08, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF8F1, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF8F7, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x69E9, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF8E3, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x485B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x495B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8148, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x495B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x89C8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x88C8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8130, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4957, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3920, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x83C8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x83BC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x83F8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1E40, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8130, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xBCF8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xBC08, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4718, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x484D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3020, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8800, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4952, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1844, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x230D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x071B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8818, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4A51, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8010, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8958, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8810, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2108, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4308, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8010, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8898, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x494D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8008, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x88D8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x494C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8008, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4F47, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8A38, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF8CA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4849, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x493A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8048, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x69E9, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF8AB, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF8B9, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x88F8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4939, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x39E0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8348, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8938, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x80B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8978, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8130, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x81F0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x20CD, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8070, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1E64, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD1FD, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x483F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2203, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x6801, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8935, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0067, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0013, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x40BB, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x432B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8133, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1E40, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD2FD, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1C64, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2C08, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xDBF3, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF8AA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE7B6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xB5F8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2601, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0035, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3810, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4086, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x40A5, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4F33, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2C10, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xDA03, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8838, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x43A8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8038, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8878, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x43B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8078, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF89D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2C10, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xDA03, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8838, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4328, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8038, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8878, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4330, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8078, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4821, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8A00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD008, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4C15, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4924, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8860, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4288, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD103, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF891, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4824, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8060, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE78B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xB5F8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4C23, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x680D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4823, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF890, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4E22, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4F0B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0041, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x198A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x88D2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4362, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A92, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2302, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2A02, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD900, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0013, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1AE2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x19CB, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x33FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3341, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x809A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x526A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1C40, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2803, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD3ED, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE76F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xA000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1C18, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x21D0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x34F0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x9999, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1E10, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0140, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0140, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2108, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1FFF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x06E8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2710, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0560, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0562, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0564, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xABCD, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x005C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1100, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xDCBA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x234C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0FC4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1097, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xEE47, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x226F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4BE3, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0B3F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1A75, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x34DB, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x04C5, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1AB9, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4778, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x46C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE59F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF1C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE12F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x79F5, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0028, 0xD000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x1030, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x1030, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x1030, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 10 },      /* GX1_1 *//* Wait 10ms */
{ 0x002A, 0xF468, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0006, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF404, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x002A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF46E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF45A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF40E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF40C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF420, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0076, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF426, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00D4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF460, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xE304, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0081, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xE308, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0081, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xE506, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0093, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xE402, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x040C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF42A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF408, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0007, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF400, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0007, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF43C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF440, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0044, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF444, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF448, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF45C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF406, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF410, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF472, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x005C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0xF470, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x17B8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3BB0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x3BB0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05BA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05BC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05BC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0014, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05BC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0014, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05BC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01AE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0238, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01AE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0238, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0238, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05BA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01AC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01AC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0240, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x008C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x009E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01AC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00A6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05BA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0292, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05BA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00D8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01A8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x02C4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05B4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01AA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01D6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01BB, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01EF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01F9, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0203, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01CC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01EF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01AE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01B6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05BA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05C6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00D4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01AC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x02C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05B8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01AE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x17BC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3C8A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x3C8A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x081E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0414, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x040F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0014, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x040F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0422, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0146, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01D0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0554, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05DE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01D0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0410, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05DE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x081E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0144, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0414, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0552, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0144, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01D8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0552, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05E6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x008C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x040F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x049A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x009E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x040F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x04AC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0144, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x040F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0552, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00A6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0410, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x04B4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x081E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x022A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0410, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0638, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x081E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00D8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0140, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0292, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x040A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x04E6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x054E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x06A0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0818, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0142, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x016E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x040C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0438, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0550, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x057C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x014D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0182, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x018C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0196, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0417, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x044C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0456, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0460, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x055B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0590, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x059A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05A4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0158, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0182, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0422, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x044C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0566, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0590, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0146, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x014E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0410, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0418, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0554, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x055C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x081E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x082A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00D4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0144, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x028E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x040E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x04E2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0552, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x069C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x081C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0146, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0410, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0554, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0830, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 100 },     /* GX1_1 *//* Wait 100ms */
{ 0x002A, 0x023E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x023C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0240, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0031, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x024C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x200C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0320, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02C4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00E3, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0200, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0238, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x018C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0166, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00E6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0132, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0732, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x15CA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x1540, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x154A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x14D8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0302, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x14E0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0011, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0030, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0035, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0039, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0040, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0045, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0049, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x004C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0055, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0059, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x005C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0065, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0069, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x006C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0075, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x007F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0086, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x008D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x14D2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1104, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x13C8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x003A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x13CE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x05B8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x5DC0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x08B4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x08B4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x71E8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0280, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0600, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x059C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0111, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00EF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x13D6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0303, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0303, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0303, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0303, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0503, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0305, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0501, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0105, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0201, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0504, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0405, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0102, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0402, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0204, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0202, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0202, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0201, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0102, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0101, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x28AC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0518, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x1680, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x018E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x16C6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x04BE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0055, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0238, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x5DC0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0252, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x025A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4E20, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x445C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x445C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x5DC0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x026C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x1780, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0538, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x053E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x1792, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x1796, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05C9, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x179A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0260, WORD_LEN, 100 },     /* GX1_1 *//* Wait 100ms */
{ 0x002A, 0x02E0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0500, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02EE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02F6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0535, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x030A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0310, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0500, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x031E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0326, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A6B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x033A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0340, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0500, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x445C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x445C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x034E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0356, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0535, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x036A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0370, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0320, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0258, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x037E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0386, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0149, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0149, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x039A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x03D0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x03D4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A20, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0798, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0009, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x03E2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0048, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0960, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x03EE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x03EC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x03F0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0535, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0300, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0402, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A20, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0798, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0009, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x36B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0410, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0042, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0048, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0960, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A6A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0300, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02AC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x3264, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x074C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0050, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x006E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00DC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x014A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0178, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0191, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01BC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01E2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0204, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0224, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x025E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0292, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x02ED, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x033C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0383, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03C4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0050, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x006E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00DC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x014A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0178, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0191, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01BC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01E2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0204, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0224, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x025E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0292, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x02ED, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x033C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0383, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03C4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0050, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x006E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00DC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x014A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0178, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0191, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01BC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01E2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0204, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0224, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x025E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0292, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x02ED, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x033C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0383, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03C4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x08D4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x08EA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00A2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0CE6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0E01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0E00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F0F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xBF58, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x490F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x427F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x288D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xEF67, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xEFBD, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4BA1, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0445, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x722F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xEC3C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x416E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xDE94, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0BCC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xBD5C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x6945, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xCFEB, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xB380, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC308, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC0FB, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1B48, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x54E6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF1C4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7EC0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xAF01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x07C4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x68FB, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF804, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x789C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xAD70, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF5E6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x9747, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1A0C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2634, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01FC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7F2C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8FA6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xCFA0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x47DD, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2DF6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x5FA3, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xA72A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1CD2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x42C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF925, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xA38B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8345, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC486, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8F8C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x10F1, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xCC8C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2C10, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x44B7, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3284, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x06C8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC202, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x11D6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x6DEF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD020, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8CEC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xB901, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x6C08, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x07E5, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x5475, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE0C2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xCEB3, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x9DDB, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1764, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1B01, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x09B6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x89D1, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x80AD, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xAC81, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x58E7, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2243, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x5BAD, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xB9A4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0B87, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x596D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF242, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x9DE8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xA63D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8578, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xBF61, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0773, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xCE24, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3504, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x21E3, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x71E1, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD55F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xB9E5, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x195B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7E50, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xAD9A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x998B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC75E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1625, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x5890, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE021, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xA7B7, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xBAD1, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xB5DC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8D7D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x28A0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x34B8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xDFA9, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7A23, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xB98B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xB5EB, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x5C8C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1B8C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x680D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xA8D5, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1864, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x5994, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE596, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xAE03, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x9831, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x9002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xB7A8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFBB0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xE13A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2300, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2056, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x86F0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC74A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xCD28, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x02E9, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x9195, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xB203, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x82F8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD116, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x083E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x68C6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD1D6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xB4F6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x9C5C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xDDB8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x9086, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x256F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3532, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xD26C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xA9E6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x83DB, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x08DC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00C6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00E1, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00D9, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x013A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0159, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01AD, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01F0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x090A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0BCF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x18BF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0ACF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x134E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0DEA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0D7B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0DFA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1018, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0FCD, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F20, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x105C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0FDB, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1176, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0906, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0FD4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0336, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x038A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x02FC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0388, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x02DC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x036E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x02BC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0354, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x02A0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x033A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0280, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0320, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x025E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0302, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x023E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x02E4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x021C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x02C4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01FA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x02A6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01EE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0286, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01E0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0268, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01D2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x024E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01C4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x023A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01D0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0226, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01E4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0212, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0011, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x013C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x025E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0264, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0242, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x027C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0236, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0288, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0232, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0288, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0230, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0284, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0232, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x027C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0236, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0274, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0252, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x026A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01FC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x034D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x045B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x02EA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0445, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x02A4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0428, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0254, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03FB, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0207, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03C7, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01CF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0365, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x019E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x031A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0170, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x02DB, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0149, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x029E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0122, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x025D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00FE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x022E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00E4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01F1, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0006, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x10A0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00D6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x10A8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x034A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x019E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xEF10, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x116C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x013B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0123, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x1186, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0602, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x118C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0685, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0309, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x002E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x001C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x11A0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0032, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x11B2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1500, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x006A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0055, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x55BF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x5556, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05AA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xABFF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4006, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xAAAB, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF40, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x17FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFFF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x502F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFFF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF54, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x6FFF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFFF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFEF7, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0021, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2139, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0297, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7FFF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00DF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x13B0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x23C2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0010, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x08D2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x08B8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x3F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0231, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFD8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFF0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFA2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01C1, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFE1A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFD7, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFC1, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01E7, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x024F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0075, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFEB8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0170, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF9D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0275, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFE78, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x017F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0231, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFD8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFF0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFA2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01C1, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFE1A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFD7, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFC1, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01E7, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x024F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0075, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFEB8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0170, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF9D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0275, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFE78, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x017F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0231, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFD8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFF0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFA2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01C1, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFE1A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFD7, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFC1, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01E7, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x024F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0075, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFEB8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0170, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF9D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0275, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFE78, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x017F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0249, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFB9, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFF8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFEA6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0196, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF42, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFC7, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFAF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0208, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0128, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF48, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x025A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF6A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01BE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFE84, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0177, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0106, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0249, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFB9, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFF8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFEA6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0196, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF42, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFC7, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFAF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0208, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0128, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF48, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x025A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF6A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01BE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFE84, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0177, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0106, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0249, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFB9, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFF8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFEA6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0196, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF42, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFC7, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFAF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0208, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0128, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF48, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x025A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF6A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01BE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFE84, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0177, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0106, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x08C0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3FD8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x3FD8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0235, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFBD, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFF8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFEDC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01A5, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF14, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFC6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF86, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0228, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x012B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF4B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0244, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF73, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01B2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFE7F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00EF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01A2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x08C6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00C6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00E1, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00D9, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x013A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0159, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01AD, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01F0, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x193E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0958, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0086, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00A7, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00E1, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0151, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x02A3, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x099C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x005A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0040, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0019, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00D5, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00DE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03E8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0078, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF804, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8EFF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8EFF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC8FB, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xC8FA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F32, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2828, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0620, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0404, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1400, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A14, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2D0A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0408, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1008, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFFF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFFD, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1900, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4B00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x5C00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x9A00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x7C0A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x023C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F10, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A18, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0900, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0902, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0403, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0600, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0201, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1404, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0464, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x6480, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0081, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x005A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0016, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0040, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0019, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00D5, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00DE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03E8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0078, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x000A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF804, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2010, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8E32, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8E32, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x6450, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x6450, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F32, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2828, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0620, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0404, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1400, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A14, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2D0A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0808, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1008, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF1E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF19, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0604, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x191E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4B1E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0064, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2228, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3200, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x140A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x023C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F10, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A18, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0900, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0902, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0600, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0201, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1E03, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0064, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x6480, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0040, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0081, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x005A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0031, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0040, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0019, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0009, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0012, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03E8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0078, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF804, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2010, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0305, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0103, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0007, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2823, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2823, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4638, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4638, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F32, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2828, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8007, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0620, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0404, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1400, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A14, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2D0A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0880, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0808, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1008, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF1E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFF19, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0604, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x191E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4B1E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x006F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x223C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2800, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x013C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F10, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A18, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0900, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0902, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0600, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0201, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x5003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0064, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x6480, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00F3, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x005A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x004B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0040, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0019, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0009, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0012, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03E8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0020, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0078, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0008, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF804, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2010, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x05FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0305, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0103, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0007, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2823, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2823, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3228, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3228, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F32, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2828, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0606, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8007, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0620, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0404, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1400, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A14, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2D0A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0880, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0508, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A08, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x801E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0019, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0604, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x191E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4B1E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x006F, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x113C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1E00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x013C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x4000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F10, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0004, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0F00, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A18, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0900, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0903, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0800, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0106, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x5002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0010, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x003C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00C8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00C8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0064, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0064, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00FA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0100, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01F4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01EA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03E8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0041, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0078, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0155, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0006, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0009, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x01CE, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0028, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xF806, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x010C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1803, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1020, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x08FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0805, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0103, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2801, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0007, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1923, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1923, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1412, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x140D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x00FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x5004, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2828, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8007, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0820, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0303, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1D1D, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0202, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A02, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A0A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x500A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0850, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0404, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A08, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x2020, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1414, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0505, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1E1E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1E1E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x204C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x1028, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0802, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0408, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3008, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0630, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xA200, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x03FF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0300, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0303, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0808, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0106, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x5502, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0078, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x8080, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3E1A, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xFFBF, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xBE7C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0xB5BD, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x3C02, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 100 },     /* GX1_1 *//* Wait 100ms */
{ 0x002A, 0x02BC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0003, WORD_LEN, 300 },     /* GX1_1 *//* Wait 300ms */
{ 0x002A, 0x02BC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0005, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0028, 0xD000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x4214, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x001E, WORD_LEN, 0 },       /* GX1_1 */
};

/* ***** Preview1 Normal ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview1_normal_reg_settings_array_gx1_1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
};
/* ***** Preview1 Normal ***** */

/* ***** Preview1 Night ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview1_night_reg_settings_array_gx1_1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
};
/* ***** Preview1 Night ***** */

/* ***** Preview2 Normal ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview2_normal_reg_settings_array_gx1_1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x035C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0535, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
};
/* ***** Preview2 Normal ***** */

/* ***** Preview2 Night ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview2_night_reg_settings_array_gx1_1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x035C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A6B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
};
/* ***** Preview2 Night ***** */

/* ***** Preview2 Fix ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview2_fix_reg_settings_array_gx1_1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x035C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0190, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
};
/* ***** Preview2 Fix ***** */

/* ***** Preview3 Normal ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview3_normal_reg_settings_array_gx1_1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x038C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0535, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0149, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
};
/* ***** Preview3 Normal ***** */

/* ***** Preview3 Night ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview3_night_reg_settings_array_gx1_1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x038C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0A6B, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0149, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
};
/* ***** Preview3 Night ***** */

/* ***** Preview3 Fix ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_preview3_fix_reg_settings_array_gx1_1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A2, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0003, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x038C, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0149, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0149, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A6, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02A4, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x027E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
};
/* ***** Preview3 Fix ***** */

/* ***** Jpeg Still Normal ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_still_normal_reg_settings_array_gx1_1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02AA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0282, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0284, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02AC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
};
/* ***** Jpeg Still Normal ***** */

/* ***** Jpeg Still Night ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_still_night_reg_settings_array_gx1_1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02AA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0282, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0284, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02AC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
};
/* ***** Jpeg Still Night ***** */

/* ***** Jpeg Still Flash ***** */
struct s5k4eag_i2c_reg_conf
s5k4eag_still_flash_reg_settings_array_gx1_1[] = {
{ 0x0028, 0x7000, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x04C8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0002, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x16F8, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02AA, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0282, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x028E, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x0284, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
{ 0x002A, 0x02AC, WORD_LEN, 0 },       /* GX1_1 */
{ 0x0F12, 0x0001, WORD_LEN, 0 },       /* GX1_1 */
};
/* ***** Jpeg Still Flash ***** */


/* ***** CAM DEBUG ***** */
#ifdef S5K4EAG_CAMSENSOR_DEBUG
struct s5k4eag_i2c_reg_debug_conf
s5k4eag_INIT_DEBUG_reg_settings_array_gx1_1[] = {
{ 0xFCFCD000, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD0000012, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD0001030, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD0000014, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD00000A0, 0x0000, WORD_LEN, 10 },       /* CAM DEBUG */
{ 0x7000319C, 0xB538, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000319E, 0xA013, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031A0, 0x6800, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031A2, 0x9000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031A4, 0x466B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031A6, 0x8819, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031A8, 0x4811, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031AA, 0x8441, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031AC, 0x8859, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031AE, 0x8481, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031B0, 0x2200, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031B2, 0x84C2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031B4, 0x2105, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031B6, 0x8501, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031B8, 0x490E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031BA, 0x480F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031BC, 0x2401, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031BE, 0xF000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031C0, 0xF947, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031C2, 0x0022, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031C4, 0x490D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031C6, 0x480E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031C8, 0x2502, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031CA, 0xF000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031CC, 0xF941, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031CE, 0x002A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031D0, 0x490C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031D2, 0x480D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031D4, 0x2403, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031D6, 0xF000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031D8, 0xF93B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031DA, 0x490C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031DC, 0x480C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031DE, 0x0022, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031E0, 0xF000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031E2, 0xF936, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031E4, 0xBC38, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031E6, 0xBC08, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031E8, 0x4718, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031EA, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031EC, 0x4EA2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031EE, 0x00A2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031F0, 0x1C18, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031F2, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031F4, 0x3215, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031F6, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031F8, 0x9E1B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031FA, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031FC, 0x3271, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700031FE, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003200, 0x3569, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003202, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003204, 0x335F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003206, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003208, 0x04C5, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000320A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000320C, 0x33B5, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000320E, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003210, 0x79FB, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003212, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003214, 0xB570, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003216, 0x4C75, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003218, 0x208B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000321A, 0x8020, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000321C, 0x20C8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000321E, 0xF000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003220, 0xF91F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003222, 0x2000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003224, 0x80A0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003226, 0x8A21, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003228, 0x4B71, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000322A, 0x4D72, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000322C, 0x2900, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000322E, 0xD003, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003230, 0x4A71, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003232, 0x8812, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003234, 0x2A00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003236, 0xD00B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003238, 0x2101, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000323A, 0x03C9, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000323C, 0x8069, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000323E, 0x80E9, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003240, 0x80A8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003242, 0x8128, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003244, 0x2000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003246, 0x43C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003248, 0x8558, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000324A, 0xBC70, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000324C, 0xBC08, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000324E, 0x4718, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003250, 0x8069, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003252, 0x2001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003254, 0x80A0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003256, 0x8A20, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003258, 0x80E8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000325A, 0x2002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000325C, 0x80A0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000325E, 0x8A20, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003260, 0x80A8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003262, 0x2003, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003264, 0x80A0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003266, 0x8A20, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003268, 0x8128, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000326A, 0x4864, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000326C, 0x8558, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000326E, 0xE7EC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003270, 0xB5F8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003272, 0x4863, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003274, 0x4D63, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003276, 0x79C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003278, 0x4E63, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000327A, 0x2802, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000327C, 0xD129, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000327E, 0x4F62, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003280, 0x2401, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003282, 0x3FE0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003284, 0x833C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003286, 0x4861, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003288, 0x6FC1, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000328A, 0x2000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000328C, 0xF000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000328E, 0xF8F0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003290, 0x485F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003292, 0x6941, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003294, 0x485F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003296, 0x6900, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003298, 0x1A08, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000329A, 0xF000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000329C, 0xF8F1, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000329E, 0xF000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032A0, 0xF8F7, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032A2, 0x69E9, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032A4, 0x2001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032A6, 0xF000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032A8, 0xF8E3, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032AA, 0x485B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032AC, 0x495B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032AE, 0x8148, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032B0, 0x495B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032B2, 0x89C8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032B4, 0x2800, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032B6, 0xD001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032B8, 0x88C8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032BA, 0x8130, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032BC, 0x4957, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032BE, 0x2000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032C0, 0x3920, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032C2, 0x83C8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032C4, 0x83BC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032C6, 0x83F8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032C8, 0x1E40, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032CA, 0x8130, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032CC, 0xBCF8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032CE, 0xBC08, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032D0, 0x4718, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032D2, 0x484D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032D4, 0x3020, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032D6, 0x8800, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032D8, 0x4952, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032DA, 0x1844, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032DC, 0x230D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032DE, 0x071B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032E0, 0x8818, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032E2, 0x4A51, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032E4, 0x8010, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032E6, 0x8958, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032E8, 0x2800, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032EA, 0xD003, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032EC, 0x8810, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032EE, 0x2108, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032F0, 0x4308, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032F2, 0x8010, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032F4, 0x8898, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032F6, 0x494D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032F8, 0x8008, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032FA, 0x88D8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032FC, 0x494C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700032FE, 0x8008, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003300, 0x4F47, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003302, 0x8A38, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003304, 0x2800, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003306, 0xD001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003308, 0xF000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000330A, 0xF8CA, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000330C, 0x4849, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000330E, 0x493A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003310, 0x8048, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003312, 0x69E9, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003314, 0x2001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003316, 0xF000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003318, 0xF8AB, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000331A, 0xF000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000331C, 0xF8B9, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000331E, 0x88F8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003320, 0x4939, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003322, 0x39E0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003324, 0x8348, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003326, 0x8938, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003328, 0x80B0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000332A, 0x8978, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000332C, 0x8130, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000332E, 0x2000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003330, 0x81F0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003332, 0x20CD, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003334, 0x8070, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003336, 0x1E64, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003338, 0xD1FD, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000333A, 0x483F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000333C, 0x2203, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000333E, 0x6801, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003340, 0x0008, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003342, 0x8935, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003344, 0x0067, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003346, 0x0013, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003348, 0x40BB, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000334A, 0x432B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000334C, 0x8133, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000334E, 0x1E40, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003350, 0xD2FD, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003352, 0x1C64, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003354, 0x2C08, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003356, 0xDBF3, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003358, 0xF000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000335A, 0xF8AA, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000335C, 0xE7B6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000335E, 0xB5F8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003360, 0x0004, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003362, 0x2601, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003364, 0x0035, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003366, 0x0020, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003368, 0x3810, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000336A, 0x4086, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000336C, 0x40A5, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000336E, 0x4F33, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003370, 0x2C10, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003372, 0xDA03, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003374, 0x8838, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003376, 0x43A8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003378, 0x8038, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000337A, 0xE002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000337C, 0x8878, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000337E, 0x43B0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003380, 0x8078, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003382, 0xF000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003384, 0xF89D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003386, 0x2C10, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003388, 0xDA03, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000338A, 0x8838, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000338C, 0x4328, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000338E, 0x8038, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003390, 0xE002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003392, 0x8878, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003394, 0x4330, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003396, 0x8078, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003398, 0x4821, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000339A, 0x8A00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000339C, 0x2800, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000339E, 0xD008, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033A0, 0x4C15, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033A2, 0x4924, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033A4, 0x8860, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033A6, 0x4288, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033A8, 0xD103, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033AA, 0xF000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033AC, 0xF891, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033AE, 0x4824, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033B0, 0x8060, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033B2, 0xE78B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033B4, 0xB5F8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033B6, 0x4C23, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033B8, 0x680D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033BA, 0x4823, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033BC, 0xF000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033BE, 0xF890, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033C0, 0x2000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033C2, 0x4E22, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033C4, 0x4F0B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033C6, 0x0041, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033C8, 0x198A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033CA, 0x88D2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033CC, 0x4362, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033CE, 0x0A92, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033D0, 0x2302, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033D2, 0x2A02, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033D4, 0xD900, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033D6, 0x0013, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033D8, 0x1AE2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033DA, 0x19CB, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033DC, 0x33FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033DE, 0x3341, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033E0, 0x809A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033E2, 0x526A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033E4, 0x1C40, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033E6, 0x2803, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033E8, 0xD3ED, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033EA, 0xE76F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033EC, 0xA000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033EE, 0xD000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033F0, 0x1C18, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033F2, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033F4, 0x21D0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033F6, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033F8, 0x34F0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033FA, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033FC, 0x9999, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700033FE, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003400, 0x1E10, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003402, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003404, 0x0140, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003406, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003408, 0x0140, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000340A, 0xD000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000340C, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000340E, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003410, 0x2800, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003412, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003414, 0x2108, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003416, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003418, 0x1FFF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000341A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000341C, 0x1080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000341E, 0xD000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003420, 0x06E8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003422, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003424, 0x2710, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003426, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003428, 0x0560, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000342A, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000342C, 0x0562, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000342E, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003430, 0x0564, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003432, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003434, 0xABCD, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003436, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003438, 0x005C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000343A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000343C, 0x1100, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000343E, 0xD000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003440, 0xDCBA, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003442, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003444, 0x03FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003446, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003448, 0x234C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000344A, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000344C, 0x0FC4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000344E, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003450, 0x4778, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003452, 0x46C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003454, 0xC000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003456, 0xE59F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003458, 0xFF1C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000345A, 0xE12F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000345C, 0x1097, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000345E, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003460, 0x4778, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003462, 0x46C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003464, 0xC000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003466, 0xE59F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003468, 0xFF1C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000346A, 0xE12F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000346C, 0xEE47, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000346E, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003470, 0x4778, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003472, 0x46C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003474, 0xC000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003476, 0xE59F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003478, 0xFF1C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000347A, 0xE12F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000347C, 0x226F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000347E, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003480, 0x4778, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003482, 0x46C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003484, 0xC000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003486, 0xE59F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003488, 0xFF1C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000348A, 0xE12F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000348C, 0x4BE3, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000348E, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003490, 0x4778, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003492, 0x46C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003494, 0xC000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003496, 0xE59F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003498, 0xFF1C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000349A, 0xE12F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000349C, 0x0B3F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000349E, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034A0, 0x4778, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034A2, 0x46C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034A4, 0xC000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034A6, 0xE59F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034A8, 0xFF1C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034AA, 0xE12F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034AC, 0x1A75, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034AE, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034B0, 0x4778, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034B2, 0x46C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034B4, 0xC000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034B6, 0xE59F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034B8, 0xFF1C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034BA, 0xE12F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034BC, 0x34DB, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034BE, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034C0, 0x4778, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034C2, 0x46C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034C4, 0xC000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034C6, 0xE59F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034C8, 0xFF1C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034CA, 0xE12F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034CC, 0x04C5, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034CE, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034D0, 0x4778, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034D2, 0x46C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034D4, 0xC000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034D6, 0xE59F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034D8, 0xFF1C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034DA, 0xE12F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034DC, 0x1AB9, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034DE, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034E0, 0x4778, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034E2, 0x46C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034E4, 0xC000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034E6, 0xE59F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034E8, 0xFF1C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034EA, 0xE12F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034EC, 0x79F5, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700034EE, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD0001000, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD0001030, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD0001000, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD0001030, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD0001000, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD0001030, 0x0000, WORD_LEN, 10 },       /* CAM DEBUG */
{ 0xD000F468, 0x0006, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F404, 0x002A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F46E, 0x0002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F45A, 0x0002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F40E, 0x0004, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F40C, 0x0020, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F420, 0x0076, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F422, 0x0005, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F426, 0x00D4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F460, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000E304, 0x0081, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000E308, 0x0081, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000E506, 0x0093, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000E402, 0x040C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F42A, 0x0080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F408, 0x000E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F40A, 0x0007, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F400, 0x0007, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F43C, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F440, 0x0044, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F444, 0x0008, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F448, 0x0008, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F45C, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F406, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F410, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F472, 0x005C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD000F470, 0x0004, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700017B8, 0x3BB0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700017BA, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BB0, 0x0003, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BB2, 0x05BA, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BB4, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BB6, 0x05BC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BB8, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BBA, 0x05BC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BBC, 0x0014, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BBE, 0x05BC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BC0, 0x0014, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BC2, 0x05BC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BC4, 0x01AE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BC6, 0x0238, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BC8, 0x01AE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BCA, 0x0238, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BCC, 0x0238, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BCE, 0x05BA, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BD0, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BD2, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BD4, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BD6, 0x01AC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BD8, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BDA, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BDC, 0x01AC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BDE, 0x0240, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BE0, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BE2, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BE4, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BE6, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BE8, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BEA, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BEC, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BEE, 0x008C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BF0, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BF2, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BF4, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BF6, 0x009E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BF8, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BFA, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BFC, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003BFE, 0x01AC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C00, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C02, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C04, 0x00A6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C06, 0x05BA, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C08, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C0A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C0C, 0x0292, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C0E, 0x05BA, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C10, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C12, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C14, 0x00D8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C16, 0x01A8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C18, 0x02C4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C1A, 0x05B4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C1C, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C1E, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C20, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C22, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C24, 0x01AA, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C26, 0x01D6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C28, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C2A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C2C, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C2E, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C30, 0x01BB, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C32, 0x01EF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C34, 0x01F9, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C36, 0x0203, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C38, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C3A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C3C, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C3E, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C40, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C42, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C44, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C46, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C48, 0x01CC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C4A, 0x01EF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C4C, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C4E, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C50, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C52, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C54, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C56, 0x000D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C58, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C5A, 0x000D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C5C, 0x01AE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C5E, 0x01B6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C60, 0x05BA, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C62, 0x05C6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C64, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C66, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C68, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C6A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C6C, 0x00D4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C6E, 0x01AC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C70, 0x02C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C72, 0x05B8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C74, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C76, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C78, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C7A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C7C, 0x01AE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C7E, 0x05C9, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C80, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C82, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C84, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C86, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700017BC, 0x3C8A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700017BE, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C8A, 0x0003, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C8C, 0x081E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C8E, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C90, 0x0414, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C92, 0x040F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C94, 0x0820, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C96, 0x0014, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C98, 0x040F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C9A, 0x0422, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C9C, 0x0820, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003C9E, 0x0146, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CA0, 0x01D0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CA2, 0x0554, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CA4, 0x05DE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CA6, 0x01D0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CA8, 0x0410, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CAA, 0x05DE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CAC, 0x081E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CAE, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CB0, 0x0144, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CB2, 0x0414, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CB4, 0x0552, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CB6, 0x0144, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CB8, 0x01D8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CBA, 0x0552, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CBC, 0x05E6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CBE, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CC0, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CC2, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CC4, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CC6, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CC8, 0x008C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CCA, 0x040F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CCC, 0x049A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CCE, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CD0, 0x009E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CD2, 0x040F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CD4, 0x04AC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CD6, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CD8, 0x0144, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CDA, 0x040F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CDC, 0x0552, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CDE, 0x00A6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CE0, 0x0410, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CE2, 0x04B4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CE4, 0x081E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CE6, 0x022A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CE8, 0x0410, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CEA, 0x0638, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CEC, 0x081E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CEE, 0x00D8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CF0, 0x0140, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CF2, 0x0292, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CF4, 0x040A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CF6, 0x04E6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CF8, 0x054E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CFA, 0x06A0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CFC, 0x0818, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003CFE, 0x0142, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D00, 0x016E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D02, 0x040C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D04, 0x0438, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D06, 0x0550, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D08, 0x057C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D0A, 0x014D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D0C, 0x0182, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D0E, 0x018C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D10, 0x0196, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D12, 0x0417, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D14, 0x044C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D16, 0x0456, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D18, 0x0460, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D1A, 0x055B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D1C, 0x0590, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D1E, 0x059A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D20, 0x05A4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D22, 0x0158, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D24, 0x0182, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D26, 0x0422, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D28, 0x044C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D2A, 0x0566, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D2C, 0x0590, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D2E, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D30, 0x000D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D32, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D34, 0x000D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D36, 0x0146, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D38, 0x014E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D3A, 0x0410, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D3C, 0x0418, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D3E, 0x0554, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D40, 0x055C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D42, 0x081E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D44, 0x082A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D46, 0x00D4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D48, 0x0144, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D4A, 0x028E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D4C, 0x040E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D4E, 0x04E2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D50, 0x0552, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D52, 0x069C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D54, 0x081C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D56, 0x0146, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D58, 0x0410, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D5A, 0x0554, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D5C, 0x0830, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D5E, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003D60, 0x0000, WORD_LEN, 100 },       /* CAM DEBUG */
{ 0x7000023E, 0x0003, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000023C, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000240, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000242, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000244, 0x0031, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000246, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000024C, 0x200C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000024E, 0x0320, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002C4, 0x0100, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002C6, 0x00E3, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002C8, 0x0200, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002CA, 0x0238, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002CC, 0x018C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002CE, 0x0166, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002D0, 0x00E6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002D2, 0x0132, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002D4, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000732, 0x00FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700015CA, 0x0003, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001540, 0x1002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000154A, 0x0004, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014D8, 0x0302, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014E0, 0x0011, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014E2, 0x0030, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014E4, 0x0035, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014E6, 0x0039, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014E8, 0x003c, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014EA, 0x0040, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014EC, 0x0045, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014EE, 0x0049, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014F0, 0x004c, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014F2, 0x0055, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014F4, 0x0059, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014F6, 0x005c, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014F8, 0x0065, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014FA, 0x0069, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014FC, 0x006c, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014FE, 0x0075, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001500, 0x007F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001502, 0x0086, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001504, 0x008D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700014D2, 0x1104, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013C8, 0x003A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013CE, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700005B8, 0x5DC0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700005BA, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700005BC, 0x08B4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700005BE, 0x0002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700005C0, 0x08B4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700005C2, 0x0002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700005C4, 0x71E8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700005C6, 0x0002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700005C8, 0x0280, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700005CA, 0x0600, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700005CC, 0x0100, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700005CE, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000059C, 0x0111, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000059E, 0x00EF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013D6, 0x0303, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013D8, 0x0303, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013DA, 0x0303, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013DC, 0x0303, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013DE, 0x0503, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013E0, 0x0505, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013E2, 0x0505, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013E4, 0x0305, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013E6, 0x0501, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013E8, 0x0505, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013EA, 0x0505, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013EC, 0x0105, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013EE, 0x0201, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013F0, 0x0504, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013F2, 0x0405, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013F4, 0x0102, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013F6, 0x0101, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013F8, 0x0402, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013FA, 0x0204, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013FC, 0x0101, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013FE, 0x0101, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001400, 0x0202, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001402, 0x0202, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001404, 0x0101, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001406, 0x0101, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001408, 0x0201, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000140A, 0x0102, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000140C, 0x0101, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000140E, 0x0101, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001410, 0x0101, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001412, 0x0101, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001414, 0x0101, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700028AC, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000518, 0x0002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000051A, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001680, 0x018E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700016C6, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700004BE, 0x0055, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000238, 0x5DC0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000023A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000252, 0x0003, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000025A, 0x36B0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000025C, 0x36B0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000025E, 0x36B0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000260, 0x4E20, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000262, 0x445C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000264, 0x445C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000266, 0x5DC0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000268, 0x36B0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000026A, 0x36B0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000026C, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001780, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001782, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000053E, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000538, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001792, 0x05C9, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001796, 0x05C9, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000179A, 0x0260, WORD_LEN, 100 },       /* CAM DEBUG */
{ 0x700002E0, 0x0500, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002E2, 0x03C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002E4, 0x0005, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002E6, 0x36B0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002E8, 0x36B0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002EE, 0x0042, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002F6, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002F8, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002FA, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002FC, 0x0535, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002FE, 0x0190, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000030A, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000030C, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000310, 0x0500, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000312, 0x03C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000314, 0x0005, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000316, 0x36B0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000318, 0x36B0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000031E, 0x0042, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000326, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000328, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000032A, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000032C, 0x0A6B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000032E, 0x0190, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000033A, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000033C, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000340, 0x0500, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000342, 0x03C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000344, 0x0005, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000346, 0x445C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000348, 0x445C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000034E, 0x0042, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000356, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000358, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000035A, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000035C, 0x0535, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000035E, 0x0190, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000036A, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000036C, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000370, 0x0320, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000372, 0x0258, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000374, 0x0005, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000376, 0x36B0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000378, 0x36B0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000037E, 0x0042, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000386, 0x0002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000388, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000038A, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000038C, 0x0149, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000038E, 0x0149, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000039A, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000039C, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700003D0, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700003D4, 0x0A20, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700003D6, 0x0798, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700003D8, 0x0009, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700003DA, 0x36B0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700003DC, 0x36B0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700003E2, 0x0042, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700003E4, 0x0048, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700003E6, 0x03C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700003E8, 0x0960, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700003EA, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700003EE, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700003EC, 0x0002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700003F0, 0x0535, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700003F2, 0x0300, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000402, 0x0A20, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000404, 0x0798, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000406, 0x0009, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000408, 0x36B0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000040A, 0x36B0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000410, 0x0042, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000412, 0x0048, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000414, 0x03C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000416, 0x0960, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000418, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000041A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000041C, 0x0002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000041E, 0x0A6A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000420, 0x0300, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002A2, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002A6, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000028E, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002A4, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700002AC, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000027E, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000280, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003264, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000074C, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000074E, 0x000A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000750, 0x001E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000752, 0x0050, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000754, 0x006E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000756, 0x00DC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000758, 0x014A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000075A, 0x0178, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000075C, 0x0191, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000075E, 0x01BC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000760, 0x01E2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000762, 0x0204, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000764, 0x0224, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000766, 0x025E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000768, 0x0292, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000076A, 0x02ED, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000076C, 0x033C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000076E, 0x0383, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000770, 0x03C4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000772, 0x03FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000774, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000776, 0x000A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000778, 0x001E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000077A, 0x0050, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000077C, 0x006E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000077E, 0x00DC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000780, 0x014A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000782, 0x0178, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000784, 0x0191, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000786, 0x01BC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000788, 0x01E2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000078A, 0x0204, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000078C, 0x0224, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000078E, 0x025E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000790, 0x0292, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000792, 0x02ED, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000794, 0x033C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000796, 0x0383, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000798, 0x03C4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000079A, 0x03FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000079C, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000079E, 0x000A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007A0, 0x001E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007A2, 0x0050, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007A4, 0x006E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007A6, 0x00DC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007A8, 0x014A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007AA, 0x0178, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007AC, 0x0191, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007AE, 0x01BC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007B0, 0x01E2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007B2, 0x0204, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007B4, 0x0224, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007B6, 0x025E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007B8, 0x0292, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007BA, 0x02ED, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007BC, 0x033C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007BE, 0x0383, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007C0, 0x03C4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700007C2, 0x03FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008D4, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008EA, 0x00A2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008EC, 0x0080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CE6, 0x0F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CE8, 0x0E01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CEA, 0x0E01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CEC, 0x010F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CEE, 0x010E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CF0, 0x000E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CF2, 0x0E01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CF4, 0x0E01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CF6, 0x0F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CF8, 0x010E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CFA, 0x0F0F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CFC, 0x0F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CFE, 0x0F01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D00, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D02, 0x0F0F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D04, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D06, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D08, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D0A, 0x0F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D0C, 0x0E01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D0E, 0x0F01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D10, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D12, 0x010E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D14, 0x000E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D16, 0x0E01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D18, 0x0F01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D1A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D1C, 0x010E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D1E, 0x0F0F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D20, 0x0F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D22, 0x0F01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D24, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D26, 0x0F0F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D28, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D2A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D2C, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D2E, 0x0F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D30, 0x0E01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D32, 0x0F01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D34, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D36, 0x010E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D38, 0x000E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D3A, 0x0E01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D3C, 0x0F01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D3E, 0x0F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D40, 0x010E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D42, 0x0F0F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D44, 0x0F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D46, 0x0F01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D48, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D4A, 0x0F0F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D4C, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D4E, 0x0F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D50, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D52, 0x0F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D54, 0x0E01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D56, 0x0F01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D58, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D5A, 0x010E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D5C, 0x000E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D5E, 0x0E00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D60, 0x0F01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D62, 0x0F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D64, 0x010E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D66, 0x0F0F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D68, 0x0F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D6A, 0x0F01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D6C, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D6E, 0x0F0F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D70, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D72, 0x0F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D74, 0x000F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D76, 0xBF58, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D78, 0x490F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D7A, 0x427F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D7C, 0x288D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D7E, 0xEF67, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D80, 0xEFBD, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D82, 0x4BA1, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D84, 0x0445, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D86, 0x722F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D88, 0xEC3C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D8A, 0x416E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D8C, 0xDE94, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D8E, 0x0BCC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D90, 0xBD5C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D92, 0x6945, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D94, 0xCFEB, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D96, 0xB380, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D98, 0xC308, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D9A, 0xC0FB, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D9C, 0x1B48, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000D9E, 0x54E6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DA0, 0xF1C4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DA2, 0x7EC0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DA4, 0xAF01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DA6, 0x07C4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DA8, 0x68FB, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DAA, 0xF804, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DAC, 0x789C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DAE, 0xAD70, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DB0, 0xF5E6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DB2, 0x9747, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DB4, 0x1A0C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DB6, 0x2634, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DB8, 0x01FC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DBA, 0x7F2C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DBC, 0x8FA6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DBE, 0xCFA0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DC0, 0x47DD, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DC2, 0x2DF6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DC4, 0x5FA3, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DC6, 0xA72A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DC8, 0x1CD2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DCA, 0x42C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DCC, 0xF925, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DCE, 0xA38B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DD0, 0x8345, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DD2, 0xC486, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DD4, 0x8F8C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DD6, 0x10F1, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DD8, 0xCC8C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DDA, 0x2C10, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DDC, 0x44B7, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DDE, 0x3284, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DE0, 0x06C8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DE2, 0xC202, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DE4, 0x11D6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DE6, 0x6DEF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DE8, 0xD020, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DEA, 0x8CEC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DEC, 0xB901, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DEE, 0x01F4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DF0, 0x6C08, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DF2, 0x07E5, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DF4, 0x5475, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DF6, 0xE0C2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DF8, 0xCEB3, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DFA, 0x9DDB, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DFC, 0x1764, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000DFE, 0x1B01, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E00, 0x09B6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E02, 0x89D1, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E04, 0x80AD, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E06, 0xAC81, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E08, 0x58E7, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E0A, 0x2243, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E0C, 0x5BAD, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E0E, 0xB9A4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E10, 0x0B87, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E12, 0x596D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E14, 0xF242, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E16, 0x9DE8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E18, 0xA63D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E1A, 0x8578, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E1C, 0xBF61, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E1E, 0x0773, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E20, 0xCE24, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E22, 0x3504, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E24, 0x21E3, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E26, 0x71E1, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E28, 0xD55F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E2A, 0xB9E5, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E2C, 0x195B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E2E, 0x7E50, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E30, 0xAD9A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E32, 0x998B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E34, 0xC75E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E36, 0x1625, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E38, 0x5890, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E3A, 0xE021, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E3C, 0xA7B7, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E3E, 0xBAD1, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E40, 0xB5DC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E42, 0x8D7D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E44, 0x28A0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E46, 0x34B8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E48, 0xDFA9, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E4A, 0x7A23, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E4C, 0xB98B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E4E, 0xB5EB, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E50, 0x5C8C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E52, 0x1B8C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E54, 0x680D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E56, 0xA8D5, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E58, 0x1864, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E5A, 0x5994, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E5C, 0xE596, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E5E, 0xAE03, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E60, 0x9831, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E62, 0x9002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E64, 0xB7A8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E66, 0xFBB0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E68, 0xE13A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E6A, 0x2300, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E6C, 0x2056, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E6E, 0x86F0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E70, 0xC74A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E72, 0xCD28, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E74, 0x02E9, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E76, 0x9195, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E78, 0xB203, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E7A, 0x82F8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E7C, 0xD116, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E7E, 0x083E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E80, 0x68C6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E82, 0xD1D6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E84, 0xB4F6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E86, 0x9C5C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E88, 0xDDB8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E8A, 0x9086, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E8C, 0x256F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E8E, 0x3532, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E90, 0xD26C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E92, 0xA9E6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000E94, 0x83DB, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008DC, 0x00C6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008DE, 0x00E1, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008E0, 0x00D9, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008E2, 0x013A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008E4, 0x0159, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008E6, 0x01AD, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008E8, 0x01F0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000090A, 0x2000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000090C, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000090E, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000910, 0x0BCF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000912, 0x18BF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000914, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000916, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000918, 0x0ACF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000091A, 0x134E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000091C, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000091E, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000920, 0x0DEA, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000922, 0x0D7B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000924, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000926, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000928, 0x0DFA, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000092A, 0x1018, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000092C, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000092E, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000930, 0x0FCD, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000932, 0x0F20, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000934, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000936, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000938, 0x105C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000093A, 0x0FDB, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000093C, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000093E, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000940, 0x1176, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000942, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000944, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000946, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000948, 0x1000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000906, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000908, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FD4, 0x0336, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FD6, 0x038A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FD8, 0x02FC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FDA, 0x0388, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FDC, 0x02DC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FDE, 0x036E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FE0, 0x02BC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FE2, 0x0354, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FE4, 0x02A0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FE6, 0x033A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FE8, 0x0280, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FEA, 0x0320, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FEC, 0x025E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FEE, 0x0302, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FF0, 0x023E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FF2, 0x02E4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FF4, 0x021C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FF6, 0x02C4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FF8, 0x01FA, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FFA, 0x02A6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FFC, 0x01EE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000FFE, 0x0286, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001000, 0x01E0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001002, 0x0268, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001004, 0x01D2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001006, 0x024E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001008, 0x01C4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000100A, 0x023A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000100C, 0x01D0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000100E, 0x0226, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001010, 0x01E4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001012, 0x0212, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001014, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001016, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001018, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000101A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000101C, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000101E, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001020, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001022, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001024, 0x0005, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001026, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001028, 0x0011, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000102A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000102C, 0x013C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000102E, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001030, 0x025E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001032, 0x0264, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001034, 0x0242, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001036, 0x027C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001038, 0x0236, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000103A, 0x0288, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000103C, 0x0232, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000103E, 0x0288, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001040, 0x0230, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001042, 0x0284, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001044, 0x0232, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001046, 0x027C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001048, 0x0236, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000104A, 0x0274, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000104C, 0x0252, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000104E, 0x026A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001050, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001052, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001054, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001056, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001058, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000105A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000105C, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000105E, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001060, 0x0003, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001062, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001064, 0x000A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001066, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001068, 0x01FC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000106A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000106C, 0x034D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000106E, 0x045B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001070, 0x02EA, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001072, 0x0445, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001074, 0x02A4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001076, 0x0428, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001078, 0x0254, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000107A, 0x03FB, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000107C, 0x0207, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000107E, 0x03C7, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001080, 0x01CF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001082, 0x0365, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001084, 0x019E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001086, 0x031A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001088, 0x0170, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000108A, 0x02DB, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000108C, 0x0149, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000108E, 0x029E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001090, 0x0122, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001092, 0x025D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001094, 0x00FE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001096, 0x022E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001098, 0x00E4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000109A, 0x01F1, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000109C, 0x0006, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700010A0, 0x000C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700010A4, 0x00D6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700010A8, 0x034A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700010AA, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700010AC, 0x019E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700010AE, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700010B0, 0xEF10, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700010B2, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000116C, 0x013B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000116E, 0x0123, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001186, 0x0602, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000118C, 0x0685, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000118E, 0x0309, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001190, 0x002E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70001192, 0x001C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011A0, 0x0032, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011A2, 0x001E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011B2, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011B4, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011B6, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011B8, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011BA, 0x0004, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011BC, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011BE, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011C0, 0x1500, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011C2, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011C4, 0x006A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011C6, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011C8, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011CA, 0x7F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011CC, 0x0055, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011CE, 0x55BF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011D0, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011D2, 0x5556, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011D4, 0xff00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011D6, 0x05AA, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011D8, 0xABFF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011DA, 0x4006, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011DC, 0xAAAB, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011DE, 0xFF40, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011E0, 0x17FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011E2, 0xFFFF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011E4, 0x502F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011E6, 0xFFFF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011E8, 0xFF54, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011EA, 0x6FFF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011EC, 0xFFFF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011EE, 0xFEF7, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011F0, 0x0021, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011F2, 0x2139, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011F4, 0x0297, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011F6, 0x7FFF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011F8, 0x00DF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700011FA, 0x000E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700013B0, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700023C2, 0x0020, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700023C4, 0x00C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700023C6, 0x0010, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700023C8, 0x00C0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008D2, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008B8, 0x3F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008BA, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F00, 0x0231, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F02, 0xFFD8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F04, 0xFFF0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F06, 0xFFA2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F08, 0x01C1, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F0A, 0xFE1A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F0C, 0xFFD7, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F0E, 0xFFC1, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F10, 0x01E7, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F12, 0x024F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F14, 0x0075, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F16, 0xFEB8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F18, 0x0170, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F1A, 0xFF9D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F1C, 0x0275, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F1E, 0xFE78, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F20, 0x017F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F22, 0x010B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F24, 0x0231, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F26, 0xFFD8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F28, 0xFFF0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F2A, 0xFFA2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F2C, 0x01C1, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F2E, 0xFE1A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F30, 0xFFD7, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F32, 0xFFC1, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F34, 0x01E7, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F36, 0x024F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F38, 0x0075, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F3A, 0xFEB8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F3C, 0x0170, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F3E, 0xFF9D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F40, 0x0275, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F42, 0xFE78, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F44, 0x017F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F46, 0x010B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F48, 0x0231, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F4A, 0xFFD8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F4C, 0xFFF0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F4E, 0xFFA2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F50, 0x01C1, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F52, 0xFE1A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F54, 0xFFD7, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F56, 0xFFC1, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F58, 0x01E7, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F5A, 0x024F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F5C, 0x0075, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F5E, 0xFEB8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F60, 0x0170, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F62, 0xFF9D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F64, 0x0275, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F66, 0xFE78, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F68, 0x017F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F6A, 0x010B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F6C, 0x0249, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F6E, 0xFFB9, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F70, 0xFFF8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F72, 0xFEA6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F74, 0x0196, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F76, 0xFF42, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F78, 0xFFC7, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F7A, 0xFFAF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F7C, 0x0208, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F7E, 0x010C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F80, 0x0128, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F82, 0xFF48, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F84, 0x025A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F86, 0xFF6A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F88, 0x01BE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F8A, 0xFE84, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F8C, 0x0177, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F8E, 0x0106, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F90, 0x0249, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F92, 0xFFB9, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F94, 0xFFF8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F96, 0xFEA6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F98, 0x0196, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F9A, 0xFF42, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F9C, 0xFFC7, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003F9E, 0xFFAF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FA0, 0x0208, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FA2, 0x010C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FA4, 0x0128, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FA6, 0xFF48, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FA8, 0x025A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FAA, 0xFF6A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FAC, 0x01BE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FAE, 0xFE84, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FB0, 0x0177, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FB2, 0x0106, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FB4, 0x0249, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FB6, 0xFFB9, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FB8, 0xFFF8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FBA, 0xFEA6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FBC, 0x0196, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FBE, 0xFF42, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FC0, 0xFFC7, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FC2, 0xFFAF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FC4, 0x0208, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FC6, 0x010C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FC8, 0x0128, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FCA, 0xFF48, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FCC, 0x025A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FCE, 0xFF6A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FD0, 0x01BE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FD2, 0xFE84, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FD4, 0x0177, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FD6, 0x0106, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008C0, 0x3FD8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008C2, 0x7000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FD8, 0x0235, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FDA, 0xFFBD, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FDC, 0xFFF8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FDE, 0xFEDC, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FE0, 0x01A5, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FE2, 0xFF14, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FE4, 0xFFC6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FE6, 0xFF86, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FE8, 0x0228, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FEA, 0x012B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FEC, 0x010D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FEE, 0xFF4B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FF0, 0x0244, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FF2, 0xFF73, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FF4, 0x01B2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FF6, 0xFE7F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FF8, 0x00EF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70003FFA, 0x01A2, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008C6, 0x00C6, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008C8, 0x00E1, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008CA, 0x00D9, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008CC, 0x013A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008CE, 0x0159, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008D0, 0x01AD, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700008D2, 0x01F0, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000193E, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000958, 0x0086, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000095A, 0x00A7, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000095C, 0x00E1, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000095E, 0x0151, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000960, 0x02A3, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000099C, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x7000099E, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009A0, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009A2, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009A4, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009A6, 0x0080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009A8, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009AA, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009AC, 0x005A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009AE, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009B0, 0x0040, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009B2, 0x0019, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009B4, 0x0100, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009B6, 0x01F4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009B8, 0x00D5, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009BA, 0x00DE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009BC, 0x0100, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009BE, 0x03E8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009C0, 0x0020, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009C2, 0x0078, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009C4, 0x01FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009C6, 0x0008, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009C8, 0x0005, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009CA, 0x01CE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009CC, 0x0008, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009CE, 0xF804, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009D0, 0x010C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009D2, 0x0003, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009D4, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009D6, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009D8, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009DA, 0x0100, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009DC, 0x0002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009DE, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009E0, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009E2, 0x8EFF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009E4, 0x8EFF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009E6, 0xC8FB, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009E8, 0xC8FA, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009EA, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009EC, 0x00FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009EE, 0x0F32, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009F0, 0x2828, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009F2, 0x0606, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009F4, 0x8002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009F6, 0x0620, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009F8, 0x001E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009FA, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009FC, 0x0505, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x700009FE, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A00, 0x0A0A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A02, 0x0404, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A04, 0x1400, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A06, 0x0A14, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A08, 0x2D0A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A0A, 0x2080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A0C, 0x0408, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A0E, 0x1008, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A10, 0xFFFF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A12, 0xFFFD, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A14, 0x0606, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A16, 0x1900, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A18, 0x4B00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A1A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A1C, 0x5C00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A1E, 0x9A00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A20, 0x7C0A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A22, 0x023C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A24, 0x4000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A26, 0x0F10, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A28, 0x0004, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A2A, 0x0F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A2C, 0x0A18, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A2E, 0x0900, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A30, 0x0902, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A32, 0x0403, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A34, 0x0600, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A36, 0x0201, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A38, 0x1404, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A3A, 0x0080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A3C, 0x0464, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A3E, 0x6480, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A40, 0x0080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A42, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A44, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A46, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A48, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A4A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A4C, 0x0080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A4E, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A50, 0x0081, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A52, 0x005A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A54, 0x0016, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A56, 0x0040, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A58, 0x0019, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A5A, 0x0100, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A5C, 0x01F4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A5E, 0x00D5, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A60, 0x00DE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A62, 0x0100, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A64, 0x03E8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A66, 0x0020, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A68, 0x0078, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A6A, 0x01FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A6C, 0x000A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A6E, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A70, 0x01CE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A72, 0x0008, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A74, 0xF804, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A76, 0x010C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A78, 0x1003, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A7A, 0x2010, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A7C, 0x05FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A7E, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A80, 0x0100, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A82, 0x0002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A84, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A86, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A88, 0x8E32, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A8A, 0x8E32, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A8C, 0x6450, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A8E, 0x6450, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A90, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A92, 0x00FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A94, 0x0F32, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A96, 0x2828, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A98, 0x0606, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A9A, 0x8002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A9C, 0x0620, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000A9E, 0x001E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AA0, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AA2, 0x0505, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AA4, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AA6, 0x0A0A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AA8, 0x0404, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AAA, 0x1400, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AAC, 0x0A14, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AAE, 0x2D0A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AB0, 0x2080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AB2, 0x0808, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AB4, 0x1008, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AB6, 0xFF1E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AB8, 0xFF19, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000ABA, 0x0604, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000ABC, 0x191E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000ABE, 0x4B1E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AC0, 0x0064, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AC2, 0x2228, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AC4, 0x3200, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AC6, 0x140A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AC8, 0x023C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000ACA, 0x4000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000ACC, 0x0F10, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000ACE, 0x0004, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AD0, 0x0F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AD2, 0x0A18, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AD4, 0x0900, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AD6, 0x0902, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AD8, 0x0003, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000ADA, 0x0600, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000ADC, 0x0201, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000ADE, 0x1E03, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AE0, 0x0080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AE2, 0x0064, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AE4, 0x6480, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AE6, 0x0040, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AE8, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AEA, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AEC, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AEE, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AF0, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AF2, 0x0080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AF4, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AF6, 0x0081, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AF8, 0x005A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AFA, 0x0031, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AFC, 0x0040, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000AFE, 0x0019, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B00, 0x0100, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B02, 0x01F4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B04, 0x0009, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B06, 0x0012, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B08, 0x0100, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B0A, 0x03E8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B0C, 0x0020, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B0E, 0x0078, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B10, 0x01FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B12, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B14, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B16, 0x01CE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B18, 0x0008, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B1A, 0xF804, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B1C, 0x010C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B1E, 0x1003, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B20, 0x2010, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B22, 0x05FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B24, 0x0305, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B26, 0x0103, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B28, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B2A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B2C, 0x0007, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B2E, 0x2823, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B30, 0x2823, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B32, 0x4638, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B34, 0x4638, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B36, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B38, 0x00FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B3A, 0x0F32, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B3C, 0x2828, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B3E, 0x0606, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B40, 0x8007, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B42, 0x0620, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B44, 0x001E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B46, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B48, 0x0505, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B4A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B4C, 0x0A0A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B4E, 0x0404, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B50, 0x1400, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B52, 0x0A14, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B54, 0x2D0A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B56, 0x0880, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B58, 0x0808, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B5A, 0x1008, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B5C, 0xFF1E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B5E, 0xFF19, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B60, 0x0604, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B62, 0x191E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B64, 0x4B1E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B66, 0x006F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B68, 0x223C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B6A, 0x2800, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B6C, 0x0A0A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B6E, 0x013C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B70, 0x4000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B72, 0x0F10, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B74, 0x0004, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B76, 0x0F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B78, 0x0A18, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B7A, 0x0900, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B7C, 0x0902, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B7E, 0x0003, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B80, 0x0600, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B82, 0x0201, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B84, 0x5003, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B86, 0x0080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B88, 0x0064, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B8A, 0x6480, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B8C, 0x0020, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B8E, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B90, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B92, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B94, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B96, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B98, 0x0080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B9A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B9C, 0x00F3, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000B9E, 0x005A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BA0, 0x004B, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BA2, 0x0040, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BA4, 0x0019, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BA6, 0x0100, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BA8, 0x01F4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BAA, 0x0009, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BAC, 0x0012, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BAE, 0x0100, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BB0, 0x03E8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BB2, 0x0020, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BB4, 0x0078, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BB6, 0x01FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BB8, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BBA, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BBC, 0x01CE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BBE, 0x0008, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BC0, 0xF804, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BC2, 0x010C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BC4, 0x1003, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BC6, 0x2010, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BC8, 0x05FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BCA, 0x0305, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BCC, 0x0103, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BCE, 0x0001, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BD0, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BD2, 0x0007, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BD4, 0x2823, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BD6, 0x2823, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BD8, 0x3228, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BDA, 0x3228, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BDC, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BDE, 0x00FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BE0, 0x0F32, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BE2, 0x2828, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BE4, 0x0606, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BE6, 0x8007, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BE8, 0x0620, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BEA, 0x001E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BEC, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BEE, 0x0505, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BF0, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BF2, 0x0A0A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BF4, 0x0404, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BF6, 0x1400, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BF8, 0x0A14, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BFA, 0x2D0A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BFC, 0x0880, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000BFE, 0x0508, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C00, 0x0A08, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C02, 0x801E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C04, 0x0019, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C06, 0x0604, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C08, 0x191E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C0A, 0x4B1E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C0C, 0x006F, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C0E, 0x113C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C10, 0x1E00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C12, 0x0A0A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C14, 0x013C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C16, 0x4000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C18, 0x0F10, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C1A, 0x0004, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C1C, 0x0F00, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C1E, 0x0A18, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C20, 0x0900, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C22, 0x0903, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C24, 0x0002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C26, 0x0800, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C28, 0x0106, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C2A, 0x5002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C2C, 0x0080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C2E, 0x0080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C30, 0x8080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C32, 0x0010, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C34, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C36, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C38, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C3A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C3C, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C3E, 0x003C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C40, 0x03FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C42, 0x00C8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C44, 0x00C8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C46, 0x0064, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C48, 0x0064, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C4A, 0x00FA, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C4C, 0x0100, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C4E, 0x01F4, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C50, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C52, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C54, 0x01EA, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C56, 0x03E8, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C58, 0x0041, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C5A, 0x0078, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C5C, 0x0155, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C5E, 0x0006, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C60, 0x0009, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C62, 0x01CE, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C64, 0x0028, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C66, 0xF806, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C68, 0x010C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C6A, 0x1803, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C6C, 0x1020, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C6E, 0x08FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C70, 0x0805, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C72, 0x0103, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C74, 0x2801, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C76, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C78, 0x0007, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C7A, 0x1923, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C7C, 0x1923, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C7E, 0x1412, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C80, 0x140D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C82, 0x0A0A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C84, 0x00FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C86, 0x5004, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C88, 0x2828, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C8A, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C8C, 0x8007, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C8E, 0x0820, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C90, 0x001E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C92, 0x0303, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C94, 0x1D1D, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C96, 0x0A0A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C98, 0x0A0A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C9A, 0x0202, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C9C, 0x0A02, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000C9E, 0x0A0A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CA0, 0x500A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CA2, 0x0850, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CA4, 0x0404, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CA6, 0x0A08, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CA8, 0x2020, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CAA, 0x1414, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CAC, 0x0505, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CAE, 0x1E1E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CB0, 0x1E1E, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CB2, 0x204C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CB4, 0x1028, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CB6, 0x0802, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CB8, 0x0408, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CBA, 0x0005, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CBC, 0x3008, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CBE, 0x0630, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CC0, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CC2, 0xA200, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CC4, 0x03FF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CC6, 0x0300, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CC8, 0x0303, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CCA, 0x0002, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CCC, 0x0808, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CCE, 0x0106, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CD0, 0x5502, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CD2, 0x0080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CD4, 0x0078, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CD6, 0x8080, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CD8, 0x0000, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CDA, 0x3E1A, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CDC, 0xFFBF, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CDE, 0xBE7C, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CE0, 0xB5BD, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CE2, 0x3C02, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0x70000CE4, 0x0001, WORD_LEN, 100 },       /* CAM DEBUG */
{ 0x700002BC, 0x0003, WORD_LEN, 300 },       /* CAM DEBUG */
{ 0x700002BC, 0x0005, WORD_LEN, 0 },       /* CAM DEBUG */
{ 0xD0004214, 0x001E, WORD_LEN, 0 },       /* CAM DEBUG */
};
#endif /* #ifdef S5K4EAG_CAMSENSOR_DEBUG */
/* ***** CAM DEBUG ***** */

struct s5k4eag_reg_t s5k4eag_regs_gx1_1 = {
  .hw_ver_addr = S5K4EAG_HWVER_REG_GX1_1,
  .rev_ver_addr = S5K4EAG_REVVER_REG_GX1_1,
  
  /* for DEBUG */
#ifdef S5K4EAG_CAMSENSOR_DEBUG
  .init_reg_DEBUG_settings = &s5k4eag_INIT_DEBUG_reg_settings_array_gx1_1[0],
	.init_reg_DEBUG_settings_size = ARRAY_SIZE(s5k4eag_INIT_DEBUG_reg_settings_array_gx1_1),
#endif /* #ifdef S5K4EAG_CAMSENSOR_DEBUG */
  /* for DEBUG */
  
  /* Init Registers */
	.init_reg_settings = &s5k4eag_init_reg_settings_array_gx1_1[0],
	.init_reg_settings_size =
		ARRAY_SIZE(s5k4eag_init_reg_settings_array_gx1_1),
  
  /* Preview1 Normal 4VGA */
  .preview1_normal_reg_settings = &s5k4eag_preview1_normal_reg_settings_array_gx1_1[0],
  .preview1_normal_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview1_normal_reg_settings_array_gx1_1),
  /* Preview1 Night 4VGA */
  .preview1_night_reg_settings = &s5k4eag_preview1_night_reg_settings_array_gx1_1[0],
  .preview1_night_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview1_night_reg_settings_array_gx1_1),
  
  /* Preview2 720p(4VGA) 24fps(Normal) */
  .preview2_normal_reg_settings = &s5k4eag_preview2_normal_reg_settings_array_gx1_1[0],
  .preview2_normal_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview2_normal_reg_settings_array_gx1_1),
  /* Preview2 720p(4VGA) 24fps(Night) */
  .preview2_night_reg_settings = &s5k4eag_preview2_night_reg_settings_array_gx1_1[0],
  .preview2_night_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview2_night_reg_settings_array_gx1_1),
  /* Preview2 720p(4VGA) 24fps(Fixed) */
  .preview2_fix_reg_settings = &s5k4eag_preview2_fix_reg_settings_array_gx1_1[0],
  .preview2_fix_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview2_fix_reg_settings_array_gx1_1),
  
  /* Preview3 FVGA 30fps(Normal) */
  .preview3_normal_reg_settings = &s5k4eag_preview3_normal_reg_settings_array_gx1_1[0],
  .preview3_normal_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview3_normal_reg_settings_array_gx1_1),
  /* Preview3 FVGA 30fps(Night) */
  .preview3_night_reg_settings = &s5k4eag_preview3_night_reg_settings_array_gx1_1[0],
  .preview3_night_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview3_night_reg_settings_array_gx1_1),
  /* Preview3 FVGA 30fps(Fixed) */
  .preview3_fix_reg_settings = &s5k4eag_preview3_fix_reg_settings_array_gx1_1[0],
  .preview3_fix_reg_settings_size =
		ARRAY_SIZE(s5k4eag_preview3_fix_reg_settings_array_gx1_1),
  
  /* Jpeg Still Normal */
  .still_normal_reg_settings = &s5k4eag_still_normal_reg_settings_array_gx1_1[0],
  .still_normal_reg_settings_size =
		ARRAY_SIZE(s5k4eag_still_normal_reg_settings_array_gx1_1),
  /* Jpeg Still Night */
  .still_night_reg_settings = &s5k4eag_still_night_reg_settings_array_gx1_1[0],
  .still_night_reg_settings_size =
		ARRAY_SIZE(s5k4eag_still_night_reg_settings_array_gx1_1),
  /* Jpeg Still Flash */
  .still_flash_reg_settings = &s5k4eag_still_flash_reg_settings_array_gx1_1[0],
  .still_flash_reg_settings_size =
		ARRAY_SIZE(s5k4eag_still_flash_reg_settings_array_gx1_1),
  
};
